#include "libcad3d.h"


INTERSECTION::INTERSECTION (WORLD *World, const char *Name, H_MATRIX Frame, 
			    PART3D *Part1, PART3D *Part2, 
			    const MATERIAL &Material) :
  PART3D (NULL, World, Material)
{
  Part = PARTIntersection (Name, Frame, 
			   Part1->GetPart(), Part1->GetWTP(),
			   Part2->GetPart(), Part2->GetWTP(), 
			   Material.GetColorID());

  Initialize ();
};


DIFFERENCE::DIFFERENCE (WORLD *World, const char *Name, H_MATRIX Frame, 
		        PART3D *Part1, PART3D *Part2, 
			const MATERIAL &Material) :
  PART3D (NULL, World, Material)
{
  Part = PARTDifference (Name, Frame, 
			 Part1->GetPart(), Part1->GetWTP(),
			 Part2->GetPart(), Part2->GetWTP(), 
			 Material.GetColorID());

  Initialize ();
};


UNION::UNION (WORLD  *World, const char *Name, H_MATRIX Frame, 
	      PART3D *Part1, PART3D *Part2, const MATERIAL &Material) :
  PART3D (NULL, World, Material)
{
  Part = PARTUnion (Name, Frame, 
		    Part1->GetPart(), Part1->GetWTP(),
		    Part2->GetPart(), Part2->GetWTP(), 
		    Material.GetColorID());

  Initialize ();
};

