#include "libcad3d.h"


BREAK::BREAK (int Reason, const char *Level, const char *Msg /* = NULL */) :
  No      (Reason),
  Message (NULL)
{
  if (Msg != NULL)
  {
    Message = new char[sizeof(Msg)+16];
    sprintf (Message, "%s %d: %s", Level, No, Msg);
  }
}


BREAK::~BREAK ()
{
  if (Message != NULL)
    free (Message);
}
  

char *BREAK::GetMsg ()
{
  return Message;
}



ERROR::ERROR (int Reason, const char *Msg /* = NULL */) :
  BREAK (Reason, "ERROR", Msg)
{
  printf ("ERROR: %d\n", Reason);
};


char *ERROR::GetErrorMsg ()
{
  if (Message == NULL)
    switch (No)
    {
      case RANGE_ERROR : return "Range Error";
      case FILE_ERROR  : return "File Error";
      case NO_DATA     : return "No Data specified";
               default : return "Unspecfied error-code";
    }
  else
    return GetMsg ();
}



WARNING::WARNING (int Reason, const char *Msg /* = NULL */) :
  BREAK (Reason, "WARNING", Msg)
{
  printf ("WARNING: %d\n", Reason);
}


char *WARNING::GetWarningMsg ()
{
  if (Message == NULL)
    switch (No)
    {
      default : return "Unspecfied warning-code";
    }
  else
    return GetMsg ();
}



HINT::HINT (int Reason, const char *Msg /* = NULL */) :
  BREAK (Reason, "HINT", Msg)
{
  printf ("HINT: %d\n", Reason);
}


char *HINT::GetHintMsg ()
{
  if (Message == NULL)
    switch (No)
    {
      default : return "Unspecfied hint-code";
    }
  else
    return GetMsg ();
}


