#include "debug.h"


void AbortTest (dual Param)
{
  PRO_START (" ")

  if (! Param)
    PRO_ABORT ("Function aborted")
  else
    PRO_ABORT1 ("Function aborted %c", '!')

  /* never reached */
  PRO_END
}

int ReturnTest (dual Param)
{
  PRO_START (" ")

  if (! Param)
    PRO_RETURN ("Function returned", 1)
  else
    PRO_RETURN1 ("Function returned %c", '!', 2)

  /* never reached */
  PRO_END
  return 0;
}


int WarningTest (dual Param)
{
  PRO_START (" ")

  if (! Param)
    PRO_WARNING ("Warning", 1)
  else
    PRO_WARNING1 ("Warning %c", '!', 1)

  /* never reached */
  PRO_END
  return 0;
}


void NestTest (int Value)
{
  PRO_START ("\n")

  PRO1 ("Value: %d\n", Value)

  if (Value == 10)
    PRO_ABORT ("End reached")

  NestTest (Value+1);

  PRO_END
}


int main (void)
{
  PRO_START ("\n")

  PRO0 ("Pro-Test (0)\n")
  PRO1 ("Pro-Test (%d)\n", 1)
  PRO2 ("Pro-Test (%d) %c\n", 2, '!')
  PRO0 ("\n")

  PRO0 ("Same...")
  PRO0 ("\\line\n")
  PRO0 ("\n")

  PRO0 ("ABORT-TEST(1):\n")
  AbortTest (FALSE);
  PRO0 ("ABORT-TEST(2):\n")
  AbortTest (TRUE);
  PRO0 ("\n")

  PRO0 ("RETURN-TEST(1):\n")
  ReturnTest (FALSE);
  PRO0 ("RETURN-TEST(2):\n")
  ReturnTest (TRUE);
  PRO0 ("\n")

  PRO0 ("WARNING-TEST(1):\n")
  WarningTest (FALSE);
  PRO0 ("WARNING-TEST(2):\n")
  WarningTest (TRUE);
  PRO0 ("\n")

  PRO0 ("NESING-TEST:\n")
  NestTest (0);

  PRO_END
  return 0;
}
