#ifndef ARRAY_H
#define ARRAY_H

/* Wenn das Widget unter Motif benutzt werden soll dann sollte USE_MOTIF */
/* im Makefile definiert werden. */

/* 
  Eigene Parameter:
  Name		     Class		RepType		Default Value
  ----		     -----		-------		-------------
  cellDistance        Thickness		int		0
  autoFill            Boolean            Boolean         False
  fixedWidth          Boolean            Boolean         False
  fixedHeight         Boolean            Boolean         False


  Constraint Parameter:
  Name		     Class		RepType		Default Value
  ----		     -----		-------		-------------
  column              Position           Position        0
  row                 Position           Position        0
  columns             Width              Dimension       1
  rows                Height             Dimension       1
  allowResize         Boolean            Boolean         False
  xAlignment          Alignment          MAlignmentType  left
  yAlignment          Alignment          MAlignmentType  top
  padX                Width              Dimension       0
  padY                Height             Dimension       0
*/

#define M_ARRAY_WIDTH_MAX  256
#define M_ARRAY_HEIGHT_MAX 1024

#define MNcellDistance "mCellDistance"
#define MNautoFill     "mAutoFill"
#define MNfixedWidth   "mFixedWidth"
#define MNfixedHeight  "mFixedHeight"

#define MNrow          "mRow"
#define MNcolumn       "mColumn"
#define MNrows         "mRows"
#define MNcolumns      "mColumns"
#define MNallowResize  "mAallowResize"
#define MNxAlignment   "mXAlignment"
#define MNyAlignment   "mYAlignment"
#define MNpadX         "mPadX"
#define MNpadY         "mPadY"

#define MCxAlignment    "MXAlignment"
#define MCyAlignment    "MYAlignment"


typedef enum 
{
  M_ALIGN_LEFT,    /* left */
  M_ALIGN_RIGHT,   /* right */
  M_ALIGN_TOP,     /* top */
  M_ALIGN_BOTTOM,  /* bottom */
  M_ALIGN_CENTER,  /* center */
  M_ALIGN_FILL     /* fill */
} MAlignmentType;


typedef struct _ArrayClassRec	*ArrayWidgetClass;
typedef struct _ArrayRec	*ArrayWidget;

extern WidgetClass arrayWidgetClass;

#endif
