#ifndef _REQ_ICONP_H
#define _REQ_ICONP_H

#include "Icon.h"
#include <Xm/XmP.h>


/* Icon class structure */
typedef struct _IconWidgetClassPart
{
  caddr_t extension;
} IconWidgetClassPart;


/* Full class record declaration for Icon class */
typedef struct _IconWidgetClassRec
{
  CoreClassPart         core_class;
  XmPrimitiveClassPart  primitive_class;
  XmLabelClassPart      label_class;
  IconWidgetClassPart   icon_class;
} IconWidgetClassRec;

extern IconWidgetClassRec iconWidgetClassRec;


/* The icon widget instance record */
typedef struct _IconWidgetPart
{
  short           Offset;
  short           Width, Height;
  unsigned char   shadow_type;
  Boolean         Armed;
  XtCallbackList  activate_callback;
  XtCallbackList  arm_callback;
  XtCallbackList  disarm_callback;
} IconWidgetPart;


/* Full instance record declaration */
typedef struct _IconWidgetRec
{
  CorePart        core;
  XmPrimitivePart primitive;
  XmLabelPart     label;
  IconWidgetPart  icon;
} IconWidgetRec;


#ifndef XtSpecificationRelease
  #define XtCallCallbackList(w,cb,cd) XtWidgetCallCallbacks (cb, cd)
#endif

#endif

