#include <Xm/Form.h>
#include <Xm/RowColumn.h>
#include <Xm/ScrolledW.h>
#include <Xm/Container.h>
#include <Xm/Label.h>
#include <Xm/LabelG.h>
#include <Xm/IconG.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>

#include <libprg.h>

#include "Array.h"
#include "Icon.h"

#include "world.xpm"

static char *Names[10] = 
{
  "Button1",     "2nd Button",  "The 3rd button",  "Knpke",  "test",
  "Hello World", "What's Up",   "Extra long testbutton", "Short", "Buttontest"
};


void Array1 ()
{
  int      count;
  Widget   Shell, Array;

  Shell = XtCreatePopupShell ("array", topLevelShellWidgetClass, 
			      AppShell, NULL, 0);

  Array = XtVaCreateManagedWidget ("array", arrayWidgetClass, Shell,
				   XmNtopAttachment,    XmATTACH_FORM,
				   XmNleftAttachment,   XmATTACH_FORM,
				   XmNrightAttachment,  XmATTACH_FORM,
				   XmNbottomAttachment, XmATTACH_FORM,
				   MNautoFill,                   True,
				   MNfixedWidth,                 True,
				   MNcellDistance,                  2,
				   NULL);

  for (count = 0; count < 5; ++count)
    XtVaCreateManagedWidget (Names[count], xmPushButtonWidgetClass, Array,
			     MNcolumn,              count,
			     MNrow,                 count,
			     MNxAlignment,   M_ALIGN_FILL,
			     MNyAlignment, M_ALIGN_CENTER,
			     MNpadX,                    0,
			     MNpadY,                    0,
			     NULL);

  /* 
     Elem = REQMakeElem (ReqBOOL, -1, -1, "test", (va_list)TRUE);
  */
  /*
  XtSetArg (args[0], MNcolumn, 1);
  XtSetArg (args[1], MNrow,    3);
  Test = REQCreateElem (Array, Elem, args, 2);  */

  XtManageChild (Shell);
  XtRealizeWidget (Shell);
  XtPopup (Shell, XtGrabNonexclusive);  
}

void SelCB (Widget widget, void *UserData, XtPointer Data)
{
  printf ("Button pressed\n");
}

void Container1 ()
{
  Arg           args[10];
  XmStringTable NameList = NULL;
  Widget        Shell, Container;
  Widget        Test, Sub;

  Shell = XtCreatePopupShell ("container", topLevelShellWidgetClass, 
			      AppShell, NULL, 0);

  NameList = (XmStringTable)malloc (sizeof(XmString) * 3);
  NameList[0] = XmStringCreate ("bla1", XmSTRING_DEFAULT_CHARSET);
  NameList[1] = XmStringCreate ("bla2", XmSTRING_DEFAULT_CHARSET);
  NameList[2] = XmStringCreate ("bla3", XmSTRING_DEFAULT_CHARSET);

  Container = XtVaCreateManagedWidget ("container", 
				       xmContainerWidgetClass,          Shell,
				       XmNentryViewType,         XmSMALL_ICON,
				       XmNautomaticSelection,   XmAUTO_SELECT,
				       XmNselectionPolicy,    XmSINGLE_SELECT,
				       XmNoutlineIndentation,              15,
				       XmNlayoutType,                XmDETAIL,
				       XmNdetailColumnHeading,       NameList,
				       XmNdetailColumnHeadingCount,         3,
				       /* XmNselectionCallback,            SelCB, */
				       NULL);
  XmStringFree (NameList[0]);
  XmStringFree (NameList[1]);
  XmStringFree (NameList[2]);
  free (NameList);

  XtSetArg (args[0], XmNoutlineState, XmEXPANDED);

  Test = XmCreateLabelGadget (Container, "testI", args, 1);
  XtManageChild (Test);

  XtSetArg (args[1], XmNentryParent, Test);
  Sub = XmCreatePushButtonGadget (Container, "testI1", args, 2);
  XtAddCallback (Sub, XmNarmCallback, SelCB, NULL);
  XtManageChild (Sub);

  XtSetArg (args[1], XmNentryParent, Sub);
  Sub = XmCreatePushButtonGadget (Container, "testI1a", args, 2);
  XtAddCallback (Sub, XmNactivateCallback, SelCB, NULL);
  XtManageChild (Sub);

  XtSetArg (args[1], XmNentryParent, Test);
  Test = XmCreatePushButtonGadget (Container, "testI2", args, 2);
  XtAddCallback (Test, XmNactivateCallback, SelCB, NULL);
  XtManageChild (Test);

  XtManageChild (Shell);
  XtRealizeWidget (Shell);
  XtPopup (Shell, XtGrabNonexclusive);    
}


void Icon1 ()
{
  Arg      args[10];
  XmString Name;
  Widget   Shell, RowCol;
  Widget   Test;

  Shell = XtCreatePopupShell ("container", topLevelShellWidgetClass, 
			      AppShell, NULL, 0);

  XtSetArg (args[0], XmNorientation, XmVERTICAL);
  XtSetArg (args[1], XmNpacking,     XmPACK_COLUMN);
  RowCol = XtCreateManagedWidget ("form", xmRowColumnWidgetClass, 
				  Shell, args, 2);

  Name = XmStringLtoRCreate ("Label", XmSTRING_DEFAULT_CHARSET);
  XtSetArg (args[0], XmNlabelString, Name);
  XtSetArg (args[1], XmNmarginTop,   45);
  Test = CreateIconLabel (RowCol, "label", args, 2, "/pic/icons/new.xpm");
  XmStringFree (Name);

  Name = XmStringLtoRCreate ("Button", XmSTRING_DEFAULT_CHARSET);
  XtSetArg (args[0], XmNlabelString, Name);
  Test = CreateIconButton (RowCol, "button", args, 2, "/pic/icons/mouse.xpm");
  XtAddCallback (Test, XmNactivateCallback, SelCB, NULL);
  XmStringFree (Name);

  XtManageChild (Shell);
  XtRealizeWidget (Shell);
  XtPopup (Shell, XtGrabNonexclusive);     
}


void SelectCB (Widget widget, void *UserData, XtPointer *Data)
{
  printf ("selected\n");
}

void OutLineCB (Widget widget, void *UserData, 
	       XmContainerOutlineCallbackStruct *Data)
{
  printf ("Outline\n");
}


void FileSel ()
{
  int        count;
  Arg        args[20];
  XmString   Headings[10];
  XmString   Details[10];
  XmString   Name;
  Pixel      fg, bg;
  Pixmap     Expand;
  Pixmap     WorldIcon, DevIcon, PartIcon;
  Pixmap     WorldMask, DevMask, PartMask;
  Widget     Shell, Form;
  Widget     Win, Container;
  WidgetList IconGadgets = NULL;

  Shell = XtCreatePopupShell ("container", topLevelShellWidgetClass, 
			      AppShell, NULL, 0);

  XtSetArg(args[0], XmNrubberPositioning, False);
  XtSetArg(args[1], XmNresizePolicy,      XmRESIZE_ANY);
  Form = XmCreateForm (Shell, "form", args, 2);
  XtManageChild (Form);

  /*
    Attribute:
    # Header, Header, Icon
  */

  XtSetArg (args[ 0], XmNwidth,                      450);
  XtSetArg (args[ 1], XmNheight,                     350);
  XtSetArg (args[ 2], XmNleftAttachment,             XmATTACH_FORM);
  XtSetArg (args[ 3], XmNrightAttachment,            XmATTACH_FORM);
  XtSetArg (args[ 4], XmNtopAttachment,              XmATTACH_FORM);
  XtSetArg (args[ 5], XmNbottomAttachment,           XmATTACH_FORM);
  XtSetArg (args[ 6], XmNresizable,                  True);
  XtSetArg (args[ 7], XmNleftOffset,                 5);
  XtSetArg (args[ 8], XmNrightOffset,                5);
  XtSetArg (args[ 9], XmNtopOffset,                  5);
  XtSetArg (args[10], XmNbottomOffset,               5);
  XtSetArg (args[11], XmNscrollingPolicy,            XmAUTOMATIC);
  XtSetArg (args[12], XmNscrollBarDisplayPolicy,     XmSTATIC);
  XtSetArg (args[13], XmNscrolledWindowMarginWidth,  5);
  XtSetArg (args[14], XmNscrolledWindowMarginHeight, 5);
  Win = XmCreateScrolledWindow (Form, "sw", args, 15);
  XtManageChild (Win);

  Headings[0] = XmStringCreateLocalized ("Object");
  Headings[1] = XmStringCreateLocalized ("DOF");
  Headings[2] = XmStringCreateLocalized ("test");
  Headings[3] = XmStringCreateLocalized ("Size");

  XtVaGetValues (Win, XmNbackground, &bg, NULL, NULL);

  Expand = TOOLMakeXPM (world_xpm, NULL, NULL, bg);

  Container = 
    XtVaCreateManagedWidget ("container",
			     xmContainerWidgetClass,      Win,
			     XmNspatialIncludeModel,      XmAPPEND,
			     XmNspatialStyle,             XmGRID,
			     XmNspatialResizeModel,       XmGROW_MINOR,
			     XmNspatialSnapModel,         XmCENTER,
			     XmNdetailColumnHeading,      Headings,
			     XmNdetailColumnHeadingCount, 4,
			     XmNlayoutType,               XmDETAIL,
			     XmNentryViewType,            XmSMALL_ICON,
			     XmNselectColor,         TOOLGetColor("lightblue"),
			     XmNoutlineIndentation,       20,
			     XmNoutlineButtonPolicy,      XmOUTLINE_BUTTON_PRESENT,
			     XmNexpandedStatePixmap,      XmUNSPECIFIED_PIXMAP,
			     NULL);
  for (count = 0; count < 4; ++count)
    XmStringFree (Headings[count]);

  XtAddCallback(Container, XmNdefaultActionCallback, 
                           (XtCallbackProc)SelectCB, NULL);
  XtAddCallback(Container, XmNoutlineChangedCallback, 
                           (XtCallbackProc)OutLineCB, NULL);

  XtVaGetValues (Container, XmNforeground, &fg,
		            XmNbackground, &bg,
		            NULL, NULL);

#if 1
  WorldIcon = XmGetPixmap (XtScreen(Shell), 
			   "/users/stefan/project/pic/icons/world_s.xpm", 
			   fg, bg);
#else
  WorldIcon = TOOLLoadXPM ("/users/stefan/project/pic/icons/world_s.xpm",
			   NULL, NULL, bg);
#endif
  DevIcon   = XmGetPixmap (XtScreen(Shell), "/pic/icons/mouse.xpm", fg, bg);
  PartIcon  = XmGetPixmap (XtScreen(Shell), "/pic/icons/save.xpm",  fg, bg);

  WorldMask = XmGetPixmapByDepth(XtScreen(Shell),
				 "/users/stefan/project/pic/icons/world_s.xpm",
				 WhitePixelOfScreen(XtScreen(Shell)),
				 BlackPixelOfScreen(XtScreen(Shell)), 1);
  DevMask   = XmGetPixmapByDepth(XtScreen(Shell), 
				 "/pic/icons/mouse.xpm",
				 WhitePixelOfScreen(XtScreen(Shell)),
				 BlackPixelOfScreen(XtScreen(Shell)), 1);
  PartMask  = XmGetPixmapByDepth(XtScreen(Shell), "/pic/icons/mouse.xpm",
				 WhitePixelOfScreen(XtScreen(Shell)),
				 BlackPixelOfScreen(XtScreen(Shell)), 1);

  if (WorldIcon == XmUNSPECIFIED_PIXMAP || DevIcon == XmUNSPECIFIED_PIXMAP ||
      PartIcon == XmUNSPECIFIED_PIXMAP)
    printf ("error\n");

  IconGadgets = (Widget *) XtMalloc(sizeof(Widget) * 10);
 
  for (count = 0; count < 4; ++count)
  {
    Details[0] = XmStringCreateLocalized ("Hello1");
    Details[1] = XmStringCreateLocalized ("Hello2");
    Details[2] = XmStringCreateLocalized ("Hello3");

    XtSetArg (args[0], XmNshadowThickness, 0);
    IconGadgets[count] = XmCreateIconGadget(Container, "ig", args, 1);

    Name = XmStringCreateLocalized ("Browser");
    XtVaSetValues (IconGadgets[count], XmNlabelString,      Name, 
		                       XmNsmallIconPixmap,  WorldIcon,
		                       XmNsmallIconMask,    WorldMask,
		                       XmNdetail,           Details,
		                       XmNdetailCount,      3,
		                       XmNoutlineState,     XmCOLLAPSED,
		                       NULL, NULL);
#if 1
    if (count > 0)
      XtVaSetValues (IconGadgets[count], XmNentryParent, IconGadgets[count-1],
		                         NULL, NULL);
#endif

    XtManageChild (IconGadgets[count]);
    XmStringFree (Name);
    XmStringFree (Details[0]);
    XmStringFree (Details[1]);
    XmStringFree (Details[2]);
  }
  /*   XtFree (IconGadgets); */

  XmContainerRelayout (Container);

  XtManageChild (Shell);
  XtRealizeWidget (Shell);
  XtPopup (Shell, XtGrabNonexclusive);    
}


void ExitPrg ()
{
  PRGExitProgram ();
}


static MENU_ENTRY SystemMenu[] = 
{
  ENTRY     ("array1",    "", "", ' ', TRUE, Array1,      NULL),
  ENTRY     ("container", "", "", ' ', TRUE, Container1,  NULL),
  ENTRY     ("icon",      "", "", ' ', TRUE, Icon1,       NULL),
  ENTRY     ("fileSel",   "", "", ' ', TRUE, FileSel,     NULL),
  MENU_LINE (PrgETCHED_IN),
  ENTRY     ("exit",      "", "", ' ', TRUE, ExitPrg,     NULL)
};

static MENU_COLUMN MenuCols[] =
{
  FUNC_MENU ("System", ' ', TRUE, SystemMenu)
};

static MENU_BAR Menu[] =
{
  MAIN_MENU ("testArray", MenuCols)
};


int main (int argc, char *argv[])
{
  char *FallbackResources[] = 
  {
    "*XmContainer.OutlineButton.shadowThickness: 0",
    NULL
  };

  PRGInitLib (argv[0], &argc, argv, FallbackResources);

  PRGCreateProgram  (argv[0], Menu);
  PRGStartProgram (NULL, NULL);

  exit (0);
}
