#ifndef _DLG_GLOBAL_H
#define _DLG_GLOBAL_H

#include <stdlib.h>
#include <stdarg.h>  

#include "libdlg.h"

/* Shell-Typen: */
#include <X11/Shell.h>

#include <Xm/DialogS.h>

/* Geometrie-Management: */
#include <Xm/Form.h>
#include <Xm/RowColumn.h>
#include <Xm/ScrolledW.h>

#include <Xm/MessageB.h>

/* Widget-Klassen: */
#include <Xm/Separator.h>
#include <Xm/SeparatoG.h>
#include <Xm/Label.h>
#include <Xm/Frame.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleB.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/ScrollBar.h>
#include <Xm/Scale.h>
#include <Xm/CascadeB.h>
#include <Xm/ArrowB.h>
#include <Xm/MenuShell.h>
#include <Xm/List.h>
#include <Xm/FileSB.h>

#if (XmVERSION>=2)
#include <Xm/Notebook.h>
#include <Xm/Container.h>
#include <Xm/PushBG.h>
#endif
#if (XmVERSION>=2 && XmREVISION>=1)
#include <Xm/IconG.h>
#endif

#include <Array.h>



#define DRAG_AND_DROP

/* In some cases 'XmRFloat' will not be found on HP-UX */
#ifndef XmRFloat
#define XmRFloat XtRFloat
#endif

#define NO_VAL_INPUT

/* Macro-Definitions: */
#define GREATER(x) (((x) >= 0.0)? 0.5:0.0)

/* size of arg-list: */
#define NUM_ARGS 20

#define POSSTEP 40
#define DlgClass "Dialog"

#define NORMAL_FONT XmSTRING_DEFAULT_CHARSET


/* Identifier fr den Boxinhalt: */
enum BOXID
{
  BOXNONE = 0,
  BOXROWS,
  BOXCOLS,
  BOXELEM,
  BOXLIST,
  BOXGRID,
  BOXARRAY
};

#define nopic_width 29
#define nopic_height 29
extern unsigned char nopic_bits[];

extern char *ElemName[];

#define ELEM_NAME(Type) ElemName[Type+1]

typedef struct
{
  byte Mask;
  int  BoxID;
  int  x, y;
  char Name[DLG_NLEN+1];
} BOX_ID;


extern BOX_ID   DLGBox            (int BoxID);
#if 0
extern BOX_ID   DLGPos            (int BoxID, int x, int y);
extern BOX_ID   DLGTab            (int BoxID, int r, int c);
#endif
extern BOX_ID   DLGName           (char *Name);

/* dlgElem.c: */
extern Widget   DLG_CreateSep     (Widget Parent, Widget Last, 
				   DLGBOX *Head,  int Pos);
extern Widget   DLG_CreateWidget  (Widget Parent, DLGELEM *Elem, 
				                  dual accelerate);

/* dlgPlace.c: */
extern void     DLG_BuildLabel    (Widget Parent, Widget Value, DLGELEM *Elem);
extern void     DLG_AdjustDlg     (DLGBOX *Head);
extern void     DLG_AdjustArrays  (DLGBOX *Head);

extern int      DLG_RunBoxCB      (DIALOG *Dlg, DLGELEM *Elem);

#endif
