/* ******************************** */
/* *** (c) Stefan Vietinghoff   *** */
/* *** reading resource-entries *** */
/* ******************************** */

#include "dlgUtils.h"

typedef struct
{
  char *String;
} RESDATATYPE;

static RESDATATYPE ResResult;

/* *********************************** */
/* *** Dictionary (Resource-Datei) *** */
/* *********************************** */

/*----------------------------------------------------------------------
  Funktion: Die Funktion sucht hnlich wie GetResourceString einen
            Eintrag in der Resourcedatei. Diese Routine ist jedoch
	    nicht von einem bestimmten Widget abhngig, sondern 
	    geht von der Application-Shell und einem Resourceeintrag
	    "Dictionary" aus. 
	    Damit knnen betimmte Texte anhand der Eintrge in der 
	    Resourcedatei bersetzt werden. Name stellt dabei ein
	    Identifier dar und darf daher keine Leerzeichen enthalten.
	    Die passenden Resoucrdateieintrge haben die Form

	      <Prg.-Name>*Dictionary.<Name>: <Text>

	    bei Eindeutigkeit kann auch 

	      <Prg.-Name>*<Name>: <Text>

	    geschrieben werden.

	    Wird kein passender Eintrag gefunden, so erhlt man den 
	    Defaultstring zurck.
	    Es ist darauf zu achten, da eine Kopie des Strings 
	    zurckgeliefert wird, deren Speicher nach Gebrauch wieder
	    freigegeben werden mu.

  INPUT:  Name     Identifier, nach dem in der Resoucedatei gesucht werden
                   soll.
	  Default  Defaulteintrag, der bei erfolgloser Suche zurck-
	           geliefert wird.
  OUTPUT: (PCHAR)  Kopie der bersetzung bzw. des Defaulteintrags
  
  Bsp.:   DLGGetResourceEntry ("HelloWorld", "Hallo Welt");
          mit Resource-Eintrag:
	  <Prg.-Name>*dictionary.HelloWorld: Hey guys !
  ----------------------------------------------------------------------*/
char *DLGGetResourceEntry (char *Name, char *Default)
{
  XtResource  ResData[1];

  ResData[0].resource_name   = Name;
  ResData[0].resource_class  = DlgClass;
  ResData[0].resource_type   = XmRString;
  ResData[0].resource_size   = 80;
  ResData[0].resource_offset = XtOffset (RESDATATYPE*, String);
  ResData[0].default_type    = XmRString;
  ResData[0].default_addr    = Default;
  
  /* Eintrag aus der Resourcedatei entnehmen: */
  XtGetSubresources (AppShell, &ResResult, "dictionary", "shellWidgetClass", 
		     ResData, 1, (ArgList)NULL, 0);

  return ResResult.String;
} 









