/* *************************************** */
/* *** (c) Stefan Vietinghoff          *** */
/* *** running a dialog-scripts        *** */
/* *************************************** */

#include <ctype.h>

#include "dlgData.h"


static char  Msg[512] = "";
static dual  RunScript = FALSE;


char *DLG_RunReqScript (DIALOG *Dlg)
{
  int        count, len;
  char       pos = 'T';
  char      *Cmd;
  TOOL_LINE *Line = NULL;
  DLGBOX    *Box;
  DLGELEM   *Elem = NULL;

  PRO_START ("\n")

  RunScript = TRUE;
  Msg[0] = '\0';

  if (! TOOLScriptRunning())
  {
    sprintf (Msg, "There's no script running");
    PRO_RETURN (Msg, Msg)
  }

#if 0
  if ((Line = TOOLGetScriptCmd()) == NULL)
  {
    /* exit-button needed, because:
       a) posibility of user buttons
       b) to differ the buttons from those in dialog which may be
          opened by user-button
    */
    strcpy (Msg, "At least one dialog-entry needed");
    PRO_RETURN (Msg, Msg)
  }

  while (Line->Type == '*' && strcmp(Dlg->Title, Line->Cmd) != 0)
  {
    TOOLNextScriptCmd ();
    Line = TOOLGetScriptCmd ();
  }
#endif

  do
  {
    if ((Line = TOOLGetScriptCmd()) == NULL)
    {
	 strcpy (Msg, "End-Of-Script reached");
	 PRO_RETURN (Msg, Msg)
    }

    if (Line->Type != '?' || Line->Cmd == NULL)
    {
      sprintf (Msg, "dialog-entry expected - found: %s", Line->Cmd);
      PRO_RETURN (Msg, Msg)
    }

    PRO1 ("SEARCHING '%s'...\n", Line->Cmd)

    len = 0;
    while (Line->Cmd[len] != '.' && Line->Cmd[len] != '\0')
	 len++;

    Cmd = Line->Cmd;
    if (Line->Cmd[len] == '.')
    {
      if (strncmp(Line->Cmd, Dlg->Title, len) == 0)
      {
	Cmd = (Line->Cmd) + len + 1;
	PRO2 ("Dlg: '%s'  Element: %s\n", Dlg->Title, Cmd)
      }
      else
      {
	sprintf (Msg, "Dlg '%s' open - found '%s'", Dlg->Title, Line->Cmd);
	PRO_RETURN (Msg, Msg)
      }
    }
    if ((Box = DLG_GetBox(Dlg->Box, DLGName(Cmd))) != NULL &&
	   (Elem = Box->Item) != NULL)
    {
      PRO3 ("\\BoxID %d (%s): %s\n", 
		  Elem->BoxID, ELEM_NAME(Elem->Type), Line->Val)

      TOOLNextScriptCmd ();

      if ((Line->Val == NULL || Line->Val[0] == '\0') && 
		Elem->Type != DlgLABEL && Elem->Type != DlgTEXT &&
		Elem->Type != DlgPROC && Elem->Type != DlgPIC && 
		Elem->Type != DlgARROW)
	   PRO0 ("\\Missing value\n")
     
      /* TODO:
   	    prfen, ob Wert zum Typ pat 
      */
      switch (Elem->Type)
      {
        case DlgEMPTY :
	  break;

        case DlgLABEL :
	  break;

        case DlgBOOL :
	  if (strncmp(Line->Val, "TRUE", 4) == 0)
	    Elem->Value.drec.Value = TRUE;
	  else
	    Elem->Value.drec.Value = FALSE;
	  if (Elem->Value.drec.FPtr != NULL)
	    Elem->Value.drec.FPtr (Elem->Dlg, Elem->BoxID);
	  break;

        case DlgINT :
	  Elem->Value.irec.Value = atoi(Line->Val);
	  if (Elem->Value.irec.FPtr != NULL)
	    Elem->Value.irec.FPtr (Elem->Dlg, Elem->BoxID);
	  break;

        case DlgDOUBLE :
	  Elem->Value.rrec.Value = atof(Line->Val);
	  if (Elem->Value.rrec.FPtr != NULL)
	    Elem->Value.rrec.FPtr (Elem->Dlg, Elem->BoxID);
	  break;

        case DlgTEXT :
	  if (Elem->Value.srec.Text != NULL)
	    free (Elem->Value.srec.Text);
	  Elem->Value.srec.Text = DLG_strcp (Line->Val);
	  if (Elem->Value.srec.FPtr != NULL)
	    Elem->Value.srec.FPtr (Elem->Dlg, Elem->BoxID);
	  break;

        case DlgSCALE :
	  Elem->Value.zrec.Val = 
	    LIMIT(Elem->Value.zrec.Min, Elem->Value.zrec.Max, atof(Line->Val));
	  if (Elem->Value.zrec.FPtr != NULL)
	    Elem->Value.zrec.FPtr (Elem->Dlg, Elem->BoxID);
	  break;

        case DlgBAR :
	  Elem->Value.brec.Val = 
	    LIMIT(Elem->Value.brec.Min, Elem->Value.brec.Max, atof(Line->Val));
	  if (Elem->Value.brec.FPtr != NULL)
	    Elem->Value.brec.FPtr (Elem->Dlg, Elem->BoxID);
	  break;

	case DlgUPDN :
	  Elem->Value.urec.Val =
	    DLG_UPDN_VAL (Elem->Value.urec.Min,  Elem->Value.urec.Max,
			  Elem->Value.urec.Step, atof(Line->Val));
	  if (Elem->Value.urec.FPtr != NULL)
	    Elem->Value.urec.FPtr (Elem->Dlg, Elem->BoxID);
	  break;

        case DlgLIST :
	  Elem->Value.lrec.Result = 
	    LIMIT(0,Elem->Value.lrec.Number-1, atoi(Line->Val));
	  if (Elem->Value.lrec.FPtr != NULL)
	    Elem->Value.lrec.FPtr (Elem->Dlg, Elem->BoxID);
	  break;

        case DlgOMENU :
	  Elem->Value.orec.Result = 
	    LIMIT(0,Elem->Value.orec.Number-1, atoi(Line->Val));
	  if (Elem->Value.orec.FPtr != NULL)
	    Elem->Value.orec.FPtr (Elem->Dlg, Elem->BoxID);
	  break;

        case DlgTBOX :
	  sscanf(Line->Val, "%d %c", &count, &pos);
	  Elem->Value.trec.Toggle[count].Value = (pos=='T')? TRUE : FALSE;
	  if (Elem->Value.trec.FPtr != NULL)
	    Elem->Value.trec.FPtr (Elem->Dlg, Elem->BoxID);
	  break;

        case DlgRBOX :
	  for (count = 0; count < Elem->Value.trec.Number; ++count)
	    Elem->Value.trec.Toggle[count].Value = FALSE;
	  Elem->Value.trec.Toggle[atoi(Line->Val)].Value = TRUE;
	  if (Elem->Value.trec.FPtr != NULL)
	    Elem->Value.trec.FPtr (Elem->Dlg, Elem->BoxID);
	  break;

        case DlgPROC :
	  if (Elem->Value.crec.FPtr != NULL)
	    Elem->Value.crec.FPtr (Elem->Dlg, Elem->BoxID);
	  break;

	case DlgARROW :
	  if (Elem->Value.arec.FPtr != NULL)
	    Elem->Value.arec.FPtr (Elem->Dlg, Elem->BoxID);
	  break;

        case DlgPIC :
	  if (Elem->Value.prec.FPtr != NULL)
	    Elem->Value.prec.FPtr (Elem->Dlg, Elem->BoxID);
	  break;

        case DlgFSEL :
        case DlgDIRSEL :
	  if (Elem->Value.grec.Files)
	  {
	    DLG_strncp (Elem->Value.grec.Default, Line->Val, PATH_MAX);
	    DLG_strncp (Elem->Value.grec.Result, Line->Val, PATH_MAX);
	  }
	  else
	    TOOLGetFileDir (Elem->Value.grec.Mask, Line->Val, PATH_MAX);
	  if (Elem->Value.grec.FPtr != NULL)
	    Elem->Value.grec.FPtr (Elem->Dlg, Elem->BoxID);
	  break;

        case DlgDIAL :
	  Elem->Value.erec.Val = 
	    LIMIT(Elem->Value.erec.Min, Elem->Value.erec.Max, atof(Line->Val));
	  if (Elem->Value.trec.FPtr != NULL)
	    Elem->Value.trec.FPtr (Elem->Dlg, Elem->BoxID);
	  break;

        case DlgSEGM :
	  Elem->Value.hrec.Val = atof (Line->Val);
	  if (Elem->Value.trec.FPtr != NULL)
	    Elem->Value.trec.FPtr (Elem->Dlg, Elem->BoxID);
	  break;

#if (XmVERSION>=2)
        case DlgNOTE :
	  PRO1 ("\\NOTE  %s\n", Line->Val)
	    break;
#endif

   	default : 
	  PRO2 ("\\WARNING: BOX-TYPE %d (%s) NOT YET SUPPORTED !\n", 
		Elem->Type, ELEM_NAME(Elem->Type))
      }
    }
    else
    {
      count = 0;
      while (count < Dlg->Buttons.Number &&
		   strcmp(Cmd, Dlg->Buttons.Data[count].Name) != 0)
	   count++;

      if (count < Dlg->Buttons.Number)
      {
	PRO0 ("\\BUTTON\n")
	  TOOLNextScriptCmd ();

	if (Dlg->Buttons.Data[count].FPtr != NULL)
	{
	  Dlg->Buttons.Data[count].FPtr (Dlg, Dlg->Buttons.Data[count].ID);
	  if (Dlg->Buttons.Result == -2)      /* dialog closed in CB */
	    PRO_RETURN ("Dialog closed in CB-Proc", NULL)
        }
	elsif (Dlg->Buttons.Data[count].Type == HELP_ID && 
	       Dlg->HelpFct != NULL)
	  Dlg->HelpFct (Dlg, Dlg->Buttons.Data[count].ID);
	else
	{
	  Dlg->Buttons.Result = Dlg->Buttons.Data[count].ID;
	  PRO_RETURN ("Dialog Button", NULL)
	}
      }
      else
      {
	sprintf (Msg, "dialog contains no element '%s'", Cmd);
	PRO_RETURN (Msg, Msg)
      }
    }
  }
  while (Line != NULL);

  sprintf (Msg, "dialog not finished !");

  PRO_END
  return Msg;
}


/* ********************************************************************* */
/* ** Locates the next relevant script-command and tests, if it       ** */
/* ** suites this dialog. On Success, NULL will be returned and       ** */
/* ** 'Number' contains the number of the pressed button              ** */
/* ** Dialogs may be selected by:                                     ** */
/* **   DialogName: Button                                            ** */
/* **   DialogName.Button                                             ** */
/* **   Button                                                        ** */
/* ********************************************************************* */
char *DLG_RunDlgScript (const char *Title, char **Button, int *Number)
{
  int        count, len;
  char      *Val;
  TOOL_LINE *Line = NULL;

  PRO_START ("\n")

  RunScript = TRUE;
  Msg[0] = '\0';

  if (! TOOLScriptRunning())
  {
    sprintf (Msg, "There's no script running");
    PRO_RETURN (Msg, Msg)
  }

  do
  {
    /* Read the actual Script-Command... */
    if ((Line = TOOLGetScriptCmd()) == NULL)
    {
	 sprintf (Msg, "dialog-entry expected");
	 PRO_RETURN (Msg, Msg)
    }

    /* Check type of command */
    if (Line->Type != '?' || Line->Cmd == NULL)
    {
	 sprintf (Msg, "dialog entry expected !");
	 PRO_RETURN (Msg, Msg)
    }

    PRO2 ("SEARCHING '%s : %s'\n", Line->Cmd, Line->Val)

    /* Locate name of dialog and button */
    len = 0;
    while (Line->Cmd[len] != '.' && Line->Cmd[len] != '\0')
	 len++;

    Val = Line->Cmd;
    if (strncmp(Line->Cmd, Title, strlen(Title)) == 0)
    {
	 PRO1 ("Dialog: '%s'\n", Title)
	   if (Line->Cmd[len] == '.')
		Val = (Line->Cmd) + len + 1;
	   else
		Val = Line->Val;
    }
    else
	 Val = Line->Cmd;

    PRO1 ("Button: %s\n", Val)

    TOOLNextScriptCmd ();

    if (Number != NULL)
    {
	 count = 0;
	 while (count < *Number && strcmp(Val, Button[count]) != 0)
	   count++;

	 if (count < *Number)
	 {
	   *Number = count;
	   PRO_RETURN ("Button found", NULL)
	 }
	 elsif (! Line->optional)
	 {
	   sprintf (Msg, "dialog contains no '%s'-button !", Val);
	   PRO_RETURN (Msg, Msg)
	 }
	 else
	   PRO0 ("skipped\n")
    }
  } while (Line != NULL);

  PRO_END
  return NULL;
}


char *DLG_RunFSScript (const char *Title, char *FileName, int Length)
{
  TOOL_LINE *Line = NULL;

  PRO_START ("\n")

  RunScript = TRUE;
  Msg[0] = '\0';

  if (! TOOLScriptRunning())
  {
    sprintf (Msg, "Ther's no script running");
    PRO_RETURN (Msg, Msg)
  }

  if ((Line = TOOLGetScriptCmd()) == NULL)
  {
    sprintf (Msg, "dialog-entry expected");
    PRO_RETURN (Msg, Msg)
  }

  while (Line->Type == '*' && strcmp(Title, Line->Cmd) != 0)
  {
    TOOLNextScriptCmd ();
    Line = TOOLGetScriptCmd ();
  }

  if (Line->Type != '?' && Line->Type != '*')
  {
    sprintf (Msg, "dialog entry expected !");
    if (FileName != NULL)
      FileName[0] = '\0';  
    PRO_RETURN (Msg, Msg)
  }

  if (FileName != NULL)
  {
    if (Line->Val == NULL)
      strncpy (FileName, Line->Cmd, Length);
    else
      strncpy (FileName, Line->Val, Length);
    FileName[Length-1] = '\0';
  }

  TOOLNextScriptCmd ();

  PRO_END
  return NULL;
}
