#ifndef _SEGMENTP_H
#define _SEGMENTP_H

#include <Xm/XmP.h>

#include "dlgSegment.h"


typedef struct _SegmentClassPart
{
  XtPointer extension;
} SegmentClassPart;


typedef struct _SegmentClassRec
{
  CoreClassPart          core_class;
  CompositeClassPart     composite_class;
  ConstraintClassPart    constraint_class;

  XmManagerClassPart     manager_class;
  XmDrawingAreaClassPart area_class;

  SegmentClassPart       segment_class;
} SegmentClassRec;


/* - - - - - - - - - - - - - - - - - */

typedef struct _SegmentPart
{
  /* resources: */
  int     Val;
  int     Digits, Decimals;

  Pixel   bg, fg;

  /* private data: */
  double  XFactor;
  double  YFactor;
  char    ValStr[16];
} SegmentPart;


typedef struct _SegmentRec
{
  CorePart          core;
  CompositePart     composite;
  ConstraintPart    constraint;

  XmManagerPart     manager;
  XmDrawingAreaPart area;

  SegmentPart       segment;
} SegmentRec;


extern SegmentClassRec segmentClassDlg;



#endif
