#ifndef _DLG_UTILS_H
#define _DLG_UTILS_H

#include "dlgGlobal.h"


#define DLG_UPDN_VAL(Min,Max,Step,Val) \
        (MIN(Max, MAX(Min, Min + (int)((Val-Min)/Step + 0.5) * Step)))


typedef void (*CBFUNCTION)(void *Data, int Param);

typedef struct
{
  dual        start;
  void       *Data;
  Widget      widget;
  Dimension   SizeX, SizeY;
  CBFUNCTION  Function;
  int         Param;
} TIMER_DATA;


extern int FSXPos;
extern int FSYPos;


char    *DLG_strcp             (const char   *String, ...);
void     DLG_strncp            (char   *Result,    const char *Source, 
				int Length);
int      DLG_GetDecimals       (double  Value);
int      DLG_GetDigits         (double  Value);
char     DLG_GetSeparator      (char   *SepString, int Number);
int      DLG_GetDigit          (double  Value,     int Pos);
void     DLG_Val2Str           (char   *Result, 
				double  Value,     int Length,   int Digits);
void     DLG_MakeRightText     (char   *Result,    char *Text,   int Length);

int      DLG_CompleteFileName  (char   *FileName,  int Length);

void     DLG_Timer             (TIMER_DATA *Data, XtIntervalId Timer);
void     DLG_UpdateSizeAndPos  (DIALOG *Dlg);

#endif



