#include "libgeo.h"

H_MATRIX GEOFullProd (H_MATRIX M1, H_MATRIX M2)
{
  int      row, col, count;
  H_MATRIX Result = Matrix_0;

  for (row = X; row <= W; ++row)
    for (col = N; col <= P; ++col)
      for (count = 0; count < 4; ++count)
	Result.m[col][row] += M1.m[count][row] * M2.m[col][count];

  return Result;
}


H_MATRIX GEOCentralMatrix (double d, int Axis)
{
  H_MATRIX Result = Matrix_1;

  if (d == 0.0)
    return Matrix_0;

  Result.m[Axis][W] = 1 / d;

  return Result;
}


POINT3D GEOCentralProj (H_MATRIX Matr, POINT3D Point)
{
  POINT3D Result;

  Result = GEOMatrixMult (Matr, Point);
  Result.z = 0.0;
  
  return Result;
}





