#ifndef SERIAL_H
#define SERIAL_H


class RS232
{
  public :
    enum BAUD
    {
      BAUD_300,
      BAUD_600,
      BAUD_1200,
      BAUD_2400,
      BAUD_4800,
      BAUD_9600,
      BAUD_19200,
      BAUD_38600
      // ...
    };

    enum DATA
    {
      BITS_7,
      BITS_8
    };

    enum STOP
    {
      STOP_NONE,
      STOP_1,
      STOP_2
    };

    enum PARITY
    {
      PARITY_NONE,
      PARITY_ODD,
      PARITY_EVEN
    };

    // Constructor / Destructor
            RS232 (BAUD    Baud   = BAUD_9600, 
		   DATA    Bits   = BITS_8,
		   PARTITY Parity = PARITY_NONE
		   STOP    Stop   = STOP_1);
    virtual ~RS232 ();

    // Methods:
    virtual int    Write  (const char *Msg, ...);
    virtual int    Read   (byte *Buffer, int BufSize);

  private :
           int     fd;           // File descriptor
    struct termios Save;         // Backup of serial configuration
};


#endif
