#include <stdarg.h>

#include <Xm/Text.h>

#include "prgGlobal.h"

/* ***************************************** */
/* ** Writes a message into info-area.    ** */
/* ** Acts like printf-function           ** */
/* ** INPUT:  Message  message and mask   ** */
/* **         ...      parameter for mask ** */
/* ** OUTPUT: (bool)   TRUE, on success   ** */
/* **                  FALSE, otherwise   ** */
/* ***************************************** */
int PRGPrintf (const char *Msg, ...)
{
  int             Result = 0;
  char            Message[1024];
  va_list         Arguments;
  XmTextPosition  Pos;

  if (Message == NULL)
    return 0;

  va_start (Arguments, Msg);
  Result = vsprintf (Message, Msg, Arguments);
  va_end (Arguments);

  if (Message[0] == '\\')
    PRO1 ("\\%s\n", Message+1)
  else
    PRO1 ("%s\n", Message)

  if (Program->Info == NULL)
    return Result;

  if (Message[0] == '\\')
  {
    Pos = XmTextGetLastPosition (Program->Info->Output);
  
    XmTextInsert (Program->Info->Output, Pos, Message+1);
    XmTextShowPosition (Program->Info->Output, 
			Pos + (XmTextPosition) strlen (Message));
  }
  else
    XmTextSetString (Program->Info->Output, Message);

  XFlush (XDisplay);

  return Result;
}

