#include <stdio.h>
#include <ctype.h>

#include "prgGlobal.h"


static char Msg[512] = "";


char *PRGRunScript (char *FileName)
{
  int         LineNo;
  TOOL_LINE  *Line = NULL;
  MENU_ENTRY *Entry = NULL;

  PRO_START ("\n")

  if (FileName == NULL)
  {
    strcpy (Msg, "Invalid Filename");
    PRO_RETURN (Msg, Msg)
  }

  if ((LineNo = TOOLOpenScript(FileName)) != 0)
  {
    sprintf (Msg, "Error loading file %s: line: %d\n", FileName, LineNo);
    PRO_RETURN (Msg, Msg)
  }

  XtSetSensitive (Program->MenuBar->widget, FALSE); /* bzw. Prg->Main */
  TOOLSetMouseCursor (Program->Main, ToolWATCH, NULL, NULL);

  while ((Line = TOOLGetScriptCmd()) != NULL)
  {
    if (Line->Type == '*')
      TOOLNextScriptCmd ();
    elsif (Line->Type != '/')
    {
      PRO1 ("Command expected: %s\n", Line->Cmd)
      sprintf (Msg, "Line: %d\n"
	            "Invalid Command: %s", Line->LineNo, Line->Cmd);
      TOOLCloseScript ();
      TOOLSetMouseCursor (Program->Main, ToolNORMAL, NULL, NULL);
      XtSetSensitive (Program->MenuBar->widget, TRUE);
      PRO_RETURN (Msg, Msg)
    }
    else
    {
      PRO1 ("Command = '%s'...\n", Line->Cmd)
      if ((Entry = PRG_SearchMenuEntry(Program->MenuBar, Line->Cmd)) == NULL)
      {
	   sprintf (Msg, "No such menu entry found: '%s'", Line->Cmd);
	   TOOLCloseScript ();
	   TOOLSetMouseCursor (Program->Main, ToolNORMAL, NULL, NULL);
	   XtSetSensitive (Program->MenuBar->widget, TRUE);
	   PRO_RETURN (Msg, Msg)
	 }
      else
	 {
	   TOOLNextScriptCmd ();
	   switch (Entry->Type)
	   {
          case PrgFUNC :
		  PRO0 ("Calling function...\n")
		  if (Entry->Data == NULL)
		    ((void(*)(void))Entry->FPtr) ();
		  else
		    ((void(*)(void*))Entry->FPtr) (Entry->Data);
		  break;

  	     case PrgTOGL :
		  PRO0 ("Calling toggle...\n")
		  /* TODO: 
			Schalterstellung (ON/OFF) aus Datei lesen 
		  */
		  ((void(*)(void*))Entry->FPtr) (Entry->Data);
		  break;

  	     default :
		  sprintf (Msg, "Unsupported menu-entry type");
		  PRO_RETURN (Msg, Msg)
	   }
      }
    }
  }

  TOOLCloseScript ();

  TOOLSetMouseCursor (Program->Main, ToolNORMAL, NULL, NULL);
  XtSetSensitive (Program->MenuBar->widget, TRUE);

  PRO_END
  return NULL;
}
