#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <math.h>

#include <Xm/Form.h>

#include <Xm/Text.h>
#include <Xm/Frame.h>

#include <Xm/PushB.h>
#include <Xm/DrawingA.h>

#include <libdlg.h> /* only needed for Work-Area, dialogs and script-test */
#include <libprg.h>
#include <libhelp.h>
#include <dlgDial.h>
#include <dlgSegment.h>

#include <icons/bomb.xpm>
#include <icons/prg.xpm>
#include <icons/printer.xpm>
#include <icons/mouse.xpm>
#include <icons/book.xpm>
#include <icons/help2.xpm>
#include <icons/clock.xpm>
#include <icons/tux.xpm>


#define GRAD(x) ((x) * 3.1415926535 / 180.0)
#define RAD(x)  ((x) / 180.0 * 3.1415926535)

#define ROUNDS    100   /* # round to go   */
#define SPEED      25   /* delay-time  20  */ 
#define POS_X     100   /* x-Position      */
#define POS_Y      12   /* y-Position      */
#define SHADOW      4   /* shadow-width    */


typedef struct
{
  int    ID;
  Pixel  bg, fg;
  Window Win;
  double Value;
  Pixmap Pic;
} DRAW_DATA;


typedef struct
{
  int x, y;
} PIXEL;

typedef struct
{
  int   num;
  PIXEL p[60];
  int   width;
} COORD;


static int        IntroW = 80, IntroH = 45;
static int        OffsX = 10, OffsY = 10;
static double     ScaleX = 1.0, ScaleY = 2.0;

char      CurrDir[PATH_MAX+1] = ".";
char      HelpDir[PATH_MAX+1] = "./help";
DRAW_DATA Anim = {0, 0, 0, 0, 0.0 }; 
Widget    Work, Draw;
COORD     Point[] = 
            {{12, {{-8, 0}, {-8, -16}, {-5, -16}, {0, -8}, {5, -16}, 
		   {8, -16}, { 8, 0}, {5, 0}, { 5, -11}, {0, -4}, 
		   {-5, -11}, {-5, 0}}, 50},
             {12, {{-8, 0}, {-8, -16}, {-5, -16}, {0, -8}, {5, -16}, 
		   {8, -16}, { 8, 0}, {5, 0}, { 5, -11}, {0, -4}, 
		   {-5, -11}, {-5, 0}}, 50},
             {12, {{-8, 0}, {-8, -16}, {-5, -16}, {0, -8}, {5, -16}, 
		   {8, -16}, { 8, 0}, {5, 0}, { 5, -11}, {0, -4}, 
		   {-5, -11}, {-5, 0}}, 50}};

#define CHARS (int)(sizeof(Point)/sizeof(COORD))


void InitWork (Widget Work)
{
  Arg    args[15];
  Widget TextBox, Frame;
  Widget Dial1, Dial2;
  Widget Segment;

  XtSetArg (args[0], XmNshadowType, XmSHADOW_IN);
  Frame = XtCreateManagedWidget ("frame", xmFrameWidgetClass, Work, args, 1);

  XtSetArg (args[0], DlgNminimum,  10);
  XtSetArg (args[1], DlgNmaximum,  80);
  XtSetArg (args[2], DlgNdigits,    3);
  XtSetArg (args[3], DlgNdecimals,  0);
  Dial1 = DLGCreateDial (Frame, "dial1", args, 4, NULL, NULL);

  XtSetArg (args[0], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg (args[1], XmNwidth,           100);
  XtSetArg (args[2], XmNheight,          100);
  Draw = XtCreateManagedWidget ("draw", xmDrawingAreaWidgetClass, 
				        Work, args, 3);

  XtSetArg (args[0], XmNleftAttachment,   XmATTACH_WIDGET);
  XtSetArg (args[1], XmNleftWidget,       Dial1);
  XtSetArg (args[2], XmNrightAttachment,  XmATTACH_WIDGET);
  XtSetArg (args[3], XmNrightWidget,      Draw);
  XtSetArg (args[4], DlgNticks,           7);
  XtSetArg (args[5], DlgNsubTicks,        3);
  Dial2 = DLGCreateDial (Work, "dial2", args, 6, NULL, NULL);

  XtSetArg (args[0], XmNleftAttachment,   XmATTACH_FORM);
  XtSetArg (args[1], XmNtopAttachment,    XmATTACH_WIDGET);
  XtSetArg (args[2], XmNtopWidget,        Dial1);
  XtSetArg (args[3], XmNfractionBase,     100);
  XtSetArg (args[4], XmNrightAttachment,  XmATTACH_POSITION);
  XtSetArg (args[5], XmNrightPosition,    50);
  XtSetArg (args[6], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg (args[7], XmNmaxLength,        80);
  XtSetArg (args[8], XmNvalue,            "Demo-text");
  XtSetArg (args[9], XmNeditMode,         XmMULTI_LINE_EDIT);
  TextBox = XmCreateScrolledText (Work, "textBox", args, 10);
  XtManageChild (TextBox);

  XtSetArg (args[0], XmNleftAttachment,   XmATTACH_WIDGET);
  XtSetArg (args[1], XmNleftWidget,       TextBox);
  XtSetArg (args[2], XmNtopAttachment,    XmATTACH_WIDGET);
  XtSetArg (args[3], XmNtopWidget,        Dial2);
  XtSetArg (args[4], XmNrightAttachment,  XmATTACH_FORM);
  XtSetArg (args[5], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg (args[6], DlgNvalue,           -16238);
  XtSetArg (args[7], DlgNdigits,          8);
  XtSetArg (args[8], DlgNdecimals,        2);
  Segment = XtCreateManagedWidget ("segment", segmentWidgetClass, 
				              Work, args, 9);
}


void Load (void)
{
  PRO0 ("Load-routine called\n")

  TOOLLoadPNG ("/pic/png/penguin.png", NULL, NULL, TRUE);
}


void RunScript (void)
{
  char  FileName[PATH_MAX+1] = "";
  char  FileMask[PATH_MAX+1] = "%s/*.cmd"; /* */
  char *Msg = NULL;

  if (DLGOpenFileSel("loadFile", FileName, PATH_MAX, 
		                 FileMask, CurrDir) == NULL)
    return;

  TOOLGetFileDir (FileName, CurrDir, PATH_MAX);

  PRO1 ("Running Script %s\n", FileName)
  if ((Msg = PRGRunScript(FileName)) != NULL)
    DLGOpenTextDialog ("scriptError", DlgWARNING, Msg, 1, "close");
  else
    PRGPrintf ("SCRIPT FINISHED SUCCESSFULLY");
}


void ExitPrg (void)
{
  if (DLGOpenTextDialog("prgExit", DlgQUESTION,
			"Realy exit the Program ?", 2, "YES", "NO") == 2)
    return;

  PRGExitProgram ();
}


void Print (void)
{
  PRGPrintf ("Print-routine missing");
}


void func3 (int Mode)
{
  PRGPrintf ("func 3 called with parameter %d", Mode);
}


static int ChangeCursor (DIALOG *Dlg, int BoxID)
{
  int Value;

  Value = (int)DLGGetUpDn (Dlg, 10);

  TOOLSetMouseCursor (Work, Value, NULL, NULL);

  return DlgCONFIRM;
}

static void ScriptTest (DIALOG *Dlg, int BoxID)
{
  PRO1 ("ScriptTest Called: %d\n", BoxID)
  DLGCloseDialog (Dlg);
}


static void SetMouse (void)
{
  int        Button;
  DIALOG *Dlg = NULL;

  Dlg = DLGNewDialog (0);
  DLGMakeRows (Dlg, 0, 2, DlgNO_LINE, 10, 20);
  DLGInsertUpDn  (Dlg, 10, "cursorID", 0.0, 152.0, 0.0, 2.0);
  DLGInsertOMenu (Dlg, 20, "scriptTest", 3, "entry1", "entry2", "entry3", 0);

  DLGSetFunction (Dlg, 10, ChangeCursor);

  DLGMakeButton (Dlg, OK_BUTTON);
  DLGMakeButton (Dlg, USER_BUTTON, "test", DlgBUTTON_RIGHT, ScriptTest, 7);
  DLGMakeButton (Dlg, CANCEL_BUTTON);

  DLGOpenDialog (Dlg, "MOUSECURSOR", DlgNORMAL, NULL);
  if ((Button = DLGGetExitButton(Dlg)) == DlgOK)
    PRO1 ("=====> VALUE: %d\n", (int)DLGGetUpDn(Dlg, 10))
  else
    PRO0 ("Dialog closed by CB-function\n")

  DLGFreeDialog (Dlg);
}


#define CYCLES 1000
#define WIDGETS 500

static void WidgetTest (void)
{
  int    count, round;
  char   Name[20];
  Widget Shell;
  WidgetList wl;
  Widget w[2501];

wl = (WidgetList) malloc (sizeof(Widget));

  for (round = 0; round < CYCLES; ++round)
  {
printf ("Create %d...\n", round);
    Shell = XtVaCreatePopupShell ("test", topLevelShellWidgetClass, AppShell,
				  XmNtitle, "test", NULL);
    w[0] = Shell;
    for (count = 0; count < WIDGETS; ++count)
    {
      sprintf (Name, "w%d", count);
      w[count+1] = XtVaCreateWidget (Name, xmFormWidgetClass, w[count], 
			             XmNmappedWhenManaged, FALSE, NULL);
      wl[0] = w[count+1];
      XtManageChildren (wl, 1);
    }

    wl[0] = Shell;
    XtManageChildren (wl, 1);

printf ("Delete...\n");

    for (count = WIDGETS; count > 0; count--)
    {
      wl[0] = w[count];
      XtUnmanageChildren (wl, 1);
      XtDestroyWidget (w[count]);
    }

    wl[0] = Shell;
    XtUnmanageChildren (wl, 1);
    XtDestroyWidget (Shell);
  }
}


static void Script (void)
{
  char  FileName[PATH_MAX+1] = "/users/stefan/test";
  char  DirMask[PATH_MAX+1]  = "*";
  FILE *fp;

  PRO_START ("\n")

  SetMouse ();

  if (access("/tmp/test", X_OK) != 0)
  {
    if ((fp = fopen("/tmp/test", "w+")) == NULL)
      PRO_ABORT ("write error\n")
    fclose (fp);
  }
  elsif (DLGOpenTextDialog("fileExists", DlgMESSAGE, 
			                 "file exists - continue ?",
			                 2, "yes", "no") == 2)
    PRO_ABORT ("aborted !\n")

  if (DLGOpenTextDialog ("clickMe", DlgMESSAGE, "click button to continue", 
			            2, "goOn", "stopMe") == 0)
    PRO0 ("=====> BUTTON 'GO ON' PRESSED\n")
  else
    PRO0 ("=====> BUTTON 'STOP ME' PRESSED\n")

  if (DLGOpenFileSel("selectFile", FileName, PATH_MAX, DirMask) == NULL)
    PRO0 ("=====> FILESEL CANCELED\n")
  else
    PRO1 ("=====> FILESEL RESULT = %s\n", FileName)

  PRO_END
}


static void WaitLoop (void)
{
  PRGPrintf ("10 sec non-blocking loop...");

  /* Starts a non-blocking loop. Other events will be processed */
  TOOLWait (MILLI_SECOND(10000));

  PRGPrintf ("\\stopped !");
}


static void sub2 (void)
{
  if (PRGSetMenuActive("/mainMenu/tools", FALSE))
  {
    DLGOpenTextDialog ("menuActive", DlgINFO, "Menu insensitivated", 1, "OK");
    PRGSetMenuActive ("/mainMenu/tools", TRUE);
  }
}

static int TestDlgCB (DIALOG *Dlg, int BoxID)
{
  PRO0 ("TestDlgCB called\n")

  switch (BoxID)
  {
    case 26 :
	 DLGOpenTextDialog ("dlgTestCB", DlgINFO, 
					"Proc-Element selected", 1, "ok");
	 break;
    case 31 :
	 DLGOpenTextDialog ("dlgTestCB", DlgINFO, 
					"Arrow-Element selected", 1, "ok");
	 break;
    case 32 :
	 DLGOpenTextDialog ("dlgTestCB", DlgINFO, 
					"Pic-Element selected", 1, "ok");
	 break;
    default :
      PRGPrintf ("Invalid BoxID specified");
  }

  return DlgCONFIRM;
}

static void TestDlg (void)
{
  int        Button;
  DIALOG *Dlg;

  Dlg = DLGNewDialog (0);
  DLGMakeCols (Dlg,  0, 4, DlgETCHED_IN DlgETCHED_IN DlgETCHED_IN, 
			            10, 20, 30, 40);
  DLGMakeRows (Dlg, 10, 6, DlgNO_LINE, 11, 12, 13, 14, 15, 16);
  DLGMakeRows (Dlg, 20, 6, DlgNO_LINE, 21, 22, 23, 24, 25, 26);
  DLGMakeRows (Dlg, 30, 6, DlgNO_LINE, 31, 32, 33, 34, 35, 36);

  DLGInsertBool    (Dlg, 11, "bool",    TRUE);
  DLGInsertInt     (Dlg, 12, "int",     43, 5);
  DLGInsertDouble  (Dlg, 13, "double",  249.77, 8, 3);
  DLGInsertText    (Dlg, 14, "text",    80, "Dies ist ein\nTest", 20, 2);
  DLGInsertScale   (Dlg, 15, "scale",   0.0, 100.0, 45.0, 1, DlgHORIZONTAL);
  DLGInsertBar     (Dlg, 16, "bar",     0.0, 10.0, 5.0, 1.0, DlgHORIZONTAL);

  DLGInsertUpDn    (Dlg, 21, "upDn",    -50.0, 50.0, 10.0, 1.0);
  DLGInsertList    (Dlg, 22, "list",    5, 4, "DM", "Dollar", "Yen", 
			                            "Lira", "Peseta", 0);
  DLGInsertOMenu   (Dlg, 23, "oMenu",   6, "RED", "YELLOW", NULL, 
			                   "GREEN", "BLUE", "VIOLETT", 3);
  DLGInsertTBox    (Dlg, 24, "tBox",    2, 3, "Value1", TRUE, "Value2", FALSE,
			                      "Value3", FALSE);
  DLGInsertRBox    (Dlg, 25, "rBox",    2, 3, "dog", "cat", "elefant", 2);
  DLGInsertProc    (Dlg, 26, "proc",    TestDlgCB);

  DLGInsertArrow   (Dlg, 31, "arrow",   DlgRIGHT, TestDlgCB);
  DLGInsertPic     (Dlg, 32, "pic",     DlgXPM, -1, -1, book_xpm, TestDlgCB);
  DLGInsertFileSel (Dlg, 33, "fSel",    "$HOME/*", 40,  /* */
			                   "$HOME/minicom.log");
  DLGInsertDial    (Dlg, 34, "dial",    0.0, 100.0, 25.0, 7, 1);
  DLGInsertSegment (Dlg, 35, "segment", 187.2, 6, 1);

  DLGMakeButton (Dlg, OK_BUTTON);
  DLGMakeButton (Dlg, USER_BUTTON, "user", DlgBUTTON_RIGHT, NULL, 10);
  DLGMakeButton (Dlg, CANCEL_BUTTON);

  DLGOpenDialog (Dlg, "dlgTest", DlgNORMAL, NULL);

  Button = DLGGetExitButton (Dlg);
  PRO1 ("Confirmed with Button %d\n", Button)
  if (Button == DlgOK)
  {
    PRO1 ("BOOL:   %s\n",       DLGGetBool(Dlg, 11)? "TRUE":"FALSE")
    PRO1 ("INT:    %d\n",       DLGGetInt(Dlg, 12))
    PRO1 ("DOUBLE: %f\n",       DLGGetDouble(Dlg, 13))
    PRO1 ("TEXT:   '%s'\n",     DLGGetText(Dlg, 14))
    PRO1 ("SCALE:  %f\n",       DLGGetScale(Dlg, 15))
    PRO1 ("BAR:    %f\n",       DLGGetBar(Dlg, 16))
    PRO1 ("UPDN:   %f\n",       DLGGetUpDn(Dlg, 21))
    PRO1 ("LIST:   %d\n",       DLGGetList(Dlg, 22))
    PRO1 ("OMENU:  %d\n",       DLGGetOMenu(Dlg, 23))
    PRO3 ("TBOX:   %c %c %d\n", DLGGetTBox(Dlg, 24, 0)? 'Y':'N', 
		                      DLGGetTBox(Dlg, 24, 1)? 'Y':'N',
		                      DLGGetTBox(Dlg, 24, 2)? 'Y':'N')
    PRO1 ("RBOX:   %d\n",       DLGGetRBox(Dlg, 25))
    PRO1 ("FSEL:   %s\n",       DLGGetFileSel(Dlg, 33))
    PRO1 ("DIAL:   %f\n",       DLGGetDial(Dlg, 34))
  }

  DLGFreeDialog (Dlg);
}


void HelpWin (int No)
{
  switch (No)
  {
    case 1 :
      HELPOpenHelpWin ("helpWindow", 
		       "FILE:$HOME/project/help/help/helpdemo.hlp",
		       0, 0, 500, 400, NULL, 0, NULL);
      break;
    case 2 :
      HELPOpenHelpWin ("helpWindow", 
		       "FILE:$HOME/project/help/help/helpdemo.hlp#concept",
		       0, 0, 500, 400, NULL, 0, NULL);
      break;
    case 3 :
      HELPOpenHelpWin ("dlgLib", 
		       "FILE:$HOME/project/help/dialog/libdlg.hlp", 
		       0, 0, 450, 400, "Bibliothek", 3, NULL);
      break;
    case 4 :
      HELPOpenHelpWin ("helpText", 
		       "text: Click "
		       "<A HREF=\"/MO/HTML/dialog/libdlg.html\">here</A> "
		       "for <BD>Main</BD> Document", 
		       0, 0, 450, 400, NULL, 0, NULL);
      break;
    case 5 :
      HELPOpenHelpWin ("dlgLib", 
		       "FILE:$HOME/project/help/highlap/highlap.hlp", 
		       0, 0, 450, 400, NULL, 0, NULL);
      break;
    default :
      HELPOpenHelpWin ("dlgLib", "FILE:/wrong.hlp", 
		       0, 0, 450, 400, NULL, 0, NULL);
  }
}


void LoadHelp (void)
{
  char FileName[256] = "$(HOME)/project/help/index.hlp";
  char FileMask[256] = "$(HOME)/project/help/*.hlp,*.html"; /* */

  if (DLGOpenFileSel ("selectHelp", FileName, 256, FileMask) != NULL)
  {
    TOOLGetFileDir (FileName, HelpDir, PATH_MAX);
    strcat (HelpDir, "/*.hlp,*.html"); /* */
    HELPOpenHelpWin ("helpFile", FileName, 0, 0, 450, 400, NULL, 0, NULL);
  }
}


static void AnimFunction (DRAW_DATA *Data)
{
  int    count, Amount, num;
  int    PosX = 0;
  double Angle, c, s;
  XPoint p[60];

  XSetForeground (XDisplay, defGC, Anim.bg);
  XFillRectangle (XDisplay, Data->Pic, defGC, 0, 0, IntroW, IntroH);
  XSetForeground (XDisplay, defGC, Anim.fg);

  for (num = 0; num < CHARS; ++num)
  {
    for (Amount = 0; Amount < 2; ++Amount)
    {
      Angle = RAD (Data->Value - PosX + Amount*180);
      c =   cos(Angle);
      s = - sin(Angle);

      if (c >= 0.0 && (Data->Value > 90.0 || Amount == 0) &&
	  (Data->Value < ROUNDS*360.0+90 || Amount == 0))
      {
	for (count = 0; count < Point[num].num; ++count)
	{
	  p[count].x = (short)(SHADOW/2 + 
					   IntroW/2 + 
					   ScaleX*Point[num].p[count].x*c + IntroW/2 * s);
	  p[count].y = (short)(SHADOW/2 + 7 - ScaleY*Point[num].p[count].y);
	}
	XSetForeground (XDisplay, defGC, BlackPixel(XDisplay, XScreen));
	XFillPolygon (XDisplay, Data->Pic, defGC, 
			    p, Point[num].num, Complex, CoordModeOrigin);
	for (count = 0; count < Point[num].num; ++count)
	{
	  p[count].x -= SHADOW;
	  p[count].y -= SHADOW;
	}
	XSetForeground (XDisplay, defGC, Anim.fg);
	XFillPolygon (XDisplay, Data->Pic, defGC, 
		      p, Point[num].num, Complex, CoordModeOrigin);
	for (count = 0; count < Point[num].num; ++count)
	{
	  p[count].x = (short)(IntroW/2 + 
	                       ScaleX*Point[num].p[count].x * c + IntroW/2 * s);
	  p[count].y = (short)(7 - ScaleY*Point[num].p[count].y);
	}
	XFillPolygon (XDisplay, Data->Pic, defGC, 
		      p, Point[num].num, Complex, CoordModeOrigin);
      }
    }
    PosX += (int)(0.8 * Point[num].width);
  }
  XCopyArea (XDisplay, Data->Pic, Data->Win, defGC, 
	               0, 0, IntroW, IntroH, OffsX, OffsY);

  Data->Value += 2.0;

  if (Data->Value > ROUNDS*360.0+180.0+20.0)
  {
    XFreePixmap (XDisplay, Data->Pic);
    if (Data->ID != -1)
      PRGStopAnim (Data->ID);
    XClearWindow (XDisplay, Data->Win);
  }
}


static void UserInit ()
{
  PRGPrintf ("User-Function called");

  Anim.bg    = TOOLGetColor ("Green");
  Anim.fg    = TOOLGetColor ("Red");
  Anim.Value = -90.0;
  Anim.Win   = XtWindow (Draw);
  Anim.Pic   = XCreatePixmap (XDisplay, Anim.Win, 
			      IntroW, IntroH, TOOLGetDepth());
  Anim.ID = PRGStartAnim ((MENU_FUNCTION)AnimFunction, &Anim, 10);
}


static void Resize ()
{
  XtVaSetValues (Work, XmNwidth, 500,
		       XmNheight, 400,
		       NULL);
}


static void LogWin ()
{
  int count;

  PRGOpenLogWindow ("LogWindow", 200, 250);
  PRGLogPrintf ("This is a very, very, very, very, very, very long line\n");
  for (count = 0; count < 30; ++count)
    PRGLogPrintf ("%2d: Dist ist ein Test\n", count);
}


int main (int argc, char **argv)
{
  int count = 1;
  Arg args[3];

  static MENU_ENTRY SystemMenu[] = 
  {
    ENTRY ("load", "",        "",   ' ', TRUE, Load,      NULL),
    ENTRY ("run",  "",        "",   ' ', TRUE, RunScript, NULL),
    ENTRY ("print","<Key>F2", "F2", ' ', TRUE, Print,     NULL),
    MENU_LINE  (PrgETCHED_IN),
    ENTRY ("exit", "",        "",   ' ', TRUE, ExitPrg,   NULL)
  };

  /* - - - - - - - - - - - - - - - - - - - - */

  static MENU_ENTRY SubSubMenu[] = 
  {
    /*    {"subsub1",  CHECK, "", "", ' ', sub1, (void*)TRUE}, */
     ENTRY ("subsub2", "", "", ' ', TRUE, sub2, NULL)
  };

  static MENU_ENTRY SubMenu[] =
  {
    TITLE    ("subMenu"),
    SWITCH   ("waitLoop",   "", "", 'w', TRUE, WaitLoop, TRUE),
    ENTRY    ("sub2",       "", "", '2', TRUE, sub2,     NULL),
    SUB_MENU ("subsub",     "", "", ' ', TRUE, SubSubMenu    ),
    ENTRY    ("testDlg",    "", "", ' ', TRUE, TestDlg,  NULL)
  };

  static MENU_ENTRY ToolsMenu[] = 
  {
    TITLE    (""),
    TITLE    ("toolsMenu"),
    SWITCH   ("func3",   "<Key>f", "f", '3', TRUE, func3,      FALSE),
    SUB_MENU ("submenu", "",       "",  ' ', TRUE, SubMenu),
    ICON     ("mouse",   "<Key>m", "m", 'm', TRUE, SetMouse,   tux_xpm),
    ENTRY    ("Widgets", "",       "",  ' ', TRUE, WidgetTest, NULL),
    ENTRY    ("script",  "<Key>s", "s", 's', TRUE, Script,     NULL),
    ENTRY    ("resize",  "",       "",  ' ', TRUE, Resize,     NULL),
    ENTRY    ("logWin",  "",       "",  ' ', TRUE, LogWin,     NULL)
  };

  /* - - - - - - - - - - - - - - - - - - - - */

  static MENU_ENTRY HelpMenu[] =
  {
    ENTRY ("helpDemo", "<Key>F1",      "F1",       'h', TRUE, HelpWin,  1),
    ENTRY ("label",    "",             "",         ' ', TRUE, HelpWin,  2),
    ENTRY ("dlgLib",   "Shift<Key>F1", "Shift+F1", 'i', TRUE, HelpWin,  3),
    ENTRY ("text",     "",             "",         't', TRUE, HelpWin,  4),
    ENTRY ("HighLAP",  "",             "",         ' ', TRUE, HelpWin,  5),
    ENTRY ("wrong",    "",             "",         ' ', TRUE, HelpWin,  6),
    MENU_LINE  (PrgETCHED_OUT),
    ENTRY ("load",     "Shift<Key>F2", "Shift+F1", 'l', TRUE, LoadHelp, NULL)
  };

  static MENU_COLUMN MenuCols[] = 
  {
    FUNC_MENU ("system", 's', TRUE, SystemMenu),
    FUNC_MENU ("tools",  ' ', TRUE, ToolsMenu),
    HELP_MENU ("help",   'h', TRUE, HelpMenu)
  };

  static MENU_BAR Menu = MAIN_MENU ("mainMenu", MenuCols);

  /* parse program parameter... */
  while (count < argc)
  {
    if (strcmp(argv[count], "--help") == 0)
    {
      printf ("%s - tests the program-library:\n", argv[0]);
      printf ("Parameter:\n");
      printf ("-cmd <ScriptFile>\tExecutes the commands in the script\n");
      exit (0);
    }
    count++;
  }

  PRGInitLib (argv[0], &argc, argv, NULL);

XtSetArg (args[0], XmNdragInitiatorProtocolStyle, XmDRAG_PREFER_RECEIVER);
XtSetArg (args[1], XmNdragReceiverProtocolStyle,  XmDRAG_DYNAMIC);
XtSetValues (XmGetXmDisplay(XDisplay), args, 2);

  PRGMakeToolBar (PrgTOP_TOOL);

  PRGAddToolIcon  (-1, -1, bomb_xpm,    PRGExitProgram, NULL, "Exit program");
  PRGAddToolIcon  (-1, -1, prg_xpm,     RunScript,      NULL, "Run Script");
  PRGAddToolIcon  (-1, -1, printer_xpm, Print,          NULL, "Print data");
  PRGAddToolSpace (10);
  PRGAddToolIcon  (-1, -1, mouse_xpm,   SetMouse,       NULL, "Change\n"
		                                              "Mouse Pointer");
  PRGAddToolIcon  (-1, -1, clock_xpm,   WaitLoop,       NULL, "Wait Loop");
  PRGAddToolSpace (20);
  PRGAddToolIcon  (-1, -1, book_xpm,    LoadHelp,       NULL, "Book");
  PRGAddToolIcon  (-1, -1, help2_xpm,   HelpWin,      (void*)1, "Help");
  PRGSetDelayTime (400);

  Work = PRGCreateProgram (argv[0], &Menu);

  InitWork (Work);

  PRGSetSize (0, 0.35);

  PRGStartProgram (UserInit, NULL);

  exit(0);
  return 0;
}

