#ifndef _MEM_H
#define _MEM_H


#ifdef __cplusplus
extern "C" {
#endif

#if 0
#ifndef __FUNCTION__
  #define __FUNCTION__ ""
#endif
#endif


extern void    MEMInitLib        (void);
extern void    MEMExitLib        (void);
extern void   *MEMMalloc         (char *FileName,   int LineNo, char *CallFkt,
				  size_t  MemSize);
extern void   *MEMCalloc         (char *FileName,   int LineNo, char *CallFkt,
				  size_t  Count,    size_t Size);
extern void   *MEMRealloc        (char *FileName,   int LineNo, char *CallFkt,
				  void *OldMemPtr,  size_t NewMemSize);
extern void    MEMFree           (char *FileName,   int LineNo, char *CallFkt,
				  void *Memory);
extern void    MEMExit           (char *FielName,   int LineNo, char *CallFkt,
				  int status);
extern size_t  MEMCountMemory    (void);
extern size_t  MEMFreeAllMemory  (long *MemSize);

#undef malloc
#define malloc(Size)\
          (MEMMalloc(__FILE__, __LINE__, __FUNCTION__, Size))

#undef calloc
#define calloc(Elem, Size)\
         (MEMCalloc(__FILE__, __LINE__, __FUNCTION__, Elem, Size))

#undef realloc
#define realloc(Ptr, Size)\
          (MEMRealloc(__FILE__, __LINE__, __FUNCTION__, Ptr, Size))

#undef free
#define free(Ptr)\
          (MEMFree(__FILE__, __LINE__, __FUNCTION__, Ptr))

#undef exit
#define exit(status)\
         (MEMExit(__FILE__, __LINE__, __FUNCTION__, status))

#ifdef __cplusplus
} /* for C++ V2.0 */
#endif


#endif
