#ifndef _MEMLIST_H
#define _MEMLIST_H

#ifndef __FUNCTION__
  #define __FUNCTION__ ""
#endif


typedef int (*COMP_FUNC)(void *Ptr1, void *Ptr2);

typedef struct MEMCELL
{            
  struct MEMCELL *Prev;
  struct MEMCELL *Next;
  void           *ValPtr;
} MEMCELL;

typedef struct MEMLIST
{
  MEMCELL *Start;
  MEMCELL *End;
  int      ValSize;
} MEMLIST; 


MEMLIST  *MEM_InitList 	     (int ElemSize);
MEMCELL  *MEM_InsertList     (MEMLIST *List, MEMCELL *ElemPtr, void *Value);
MEMCELL  *MEM_DeleteList     (MEMLIST *List, MEMCELL *ElemPtr);
MEMCELL  *MEM_GetListItem    (MEMLIST *List, void *Data, MEMCELL *StartElem,
			                     COMP_FUNC CmpFunc);

#endif
