#include <stdarg.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>

#include "libnet.h"


#define TIMEOUT 20


typedef struct
{
  char *Host;
  char  HostName[256];
  int   PortNo;
  dual  Mode;
} PRG_PARAM;


typedef struct
{
  int  Timer;
} CONNECT_DATA;


static char         Msg[SOCKET_BUF_SIZE+1] = "OK";
static char         Buffer[SOCKET_BUF_SIZE+1] = "";
static PRG_PARAM    Param   = {NULL, "localhost", -1, FALSE};
static CONNECT_DATA Connect = {1};


char *SendCmd (int SocketID, char *Command, ...)
{
  va_list Arguments;

  va_start (Arguments, Command);
  vsprintf (Buffer, Command, Arguments);
  va_end   (Arguments);

  /* printf ("Sending: %s\n", Buffer); */

  if (! NETSendCommand(SocketID, Buffer))
  {
    printf ("Connection failed/closed");
    return NULL;
  }

#if 0
  if (strncmp(Buffer, "OK", 2) != 0)
  {
    printf ("Error: %s\n", Buffer);
    return NULL;
  }
#endif

  return Buffer;
}


static void StartClient (void *Data)
{
  dual  stop = FALSE;
  int   count;
  int   SocketID = -1;
  char  letter;
  char  Command[SOCKET_BUF_SIZE] = ""; 
  char *Response = NULL;

  while (Connect.Timer < TIMEOUT && 
	 (SocketID = NETInitClient(Param.HostName, Param.PortNo)) < 0)
  {
    fprintf (stderr, ".");
    fflush (stderr);
    sleep (1);
    (Connect.Timer)++;
  }

  if (SocketID < 0)
    printf ("Connection Error !\n");
  else
  {
    printf ("ready !\n");
    do
    {
      printf ("Command: ");

      count = 0;
      do 
      {
	letter = fgetc (stdin);
	if (letter == '\b')
	  count--;
	elsif (letter != '\n')
	  Command[count++] = letter;
      }
      while (letter != '\n' && count < SOCKET_BUF_SIZE-1);
      Command[count] = '\0';

      if (count > 0 && ! (stop = (strcasecmp(Command, "exit")) == 0))
      {
	Response = SendCmd (SocketID, Command);
        printf ("Response: '%s'\n", Response);
      }
    } while (! stop);

    printf ("Closing client...");
    NETCloseClient (SocketID);
    printf ("done !\n");
  }
}


static char *ServerFkt (int SocketID, char *Command)
{
  unsigned int count;

  printf ("Command: %s\n", Command);

  for (count = 0; count < strlen(Command); count++)
    Command[count] = toupper(Command[count]);
  strcpy (Msg, Command);

  return Msg;
}

static void StartServer (void *Data)
{
  int SocketID = -1; 

  printf ("Initalize connection...\n");

  if (Param.PortNo >= 0)
    if ((SocketID = NETInitServer(Param.HostName, Param.PortNo)) < 0)
    {
      printf ("Connection failed");
      exit (1);
    }

  if (SocketID >= 0)
  {
    printf ("Running Socket-Server...\n");
    NETRunServer (SocketID, ServerFkt, 2);
  }
}


int main (int argc, char **argv)
{
  int count = 1, Value;

  if (argc < 3)
  {
    printf ("Syntax: %s <-c|-s> PortNo [HostName]\n", argv[0]);
    exit (1);
  }

  while (count < argc)
  {
    if (strncmp(argv[count], "-c", 2) == 0)
      Param.Mode = FALSE;
    elsif (strncmp(argv[count], "-s", 2) == 0)
      Param.Mode = TRUE;
    elsif ((Value = atoi(argv[count])) >= 0)
      Param.PortNo = Value;
    else
      Param.Host = argv[count];

    count++;
  }

  if (Param.Host == NULL)
    gethostname (Param.HostName, (sizeof(Param.HostName)/sizeof(char)));
  else  
    strcpy (Param.HostName, Param.Host);

  printf ("Starting %s on Host %s with Port %d\n", 
	  Param.Mode? "SERVER":"CLIENT", Param.HostName, Param.PortNo);

  if (! Param.Mode)
    StartClient (NULL);
  else
  {
    StartServer (NULL);
#ifdef NET_THREADS
    /* When using threads, the server returns immediately */
    for (;;)
      ;
#endif
  }

  exit (0);
  return 0;
}
    




