#include "libobj.h"



static int IgripColors[] = 
{
   2,  /* Grey50        -1 */
   4,  /* Grey             */
   5,  /* Grey90           */
   6,  /* White            */
   4,  /* Grey          -5 */
   1,  /* Black            */
   8,  /* medium Red       */
  17,  /* medium Green     */
  22,  /* medium Blue      */
  13,  /* Yellow       -10 */
  25,  /* Cyan             */
  26,  /* Purple           */  
  11,  /* Orange           */  
  29,  /* Magenta          */
  30,  /* Cherry       -15 */
  24,  /* light Blue       */
  31,  /* Brown            */
  16,  /* Lime             */
  34,  /* Tan              */
  12,  /* Gold         -20 */
  20,  /* Steel Blue       */
  19,  /* Turquoise        */ 
  32,  /* Sienna           */
  35,  /* Peachpuff        */
  33,  /* Peru         -25 */
  14,  /* LemonChiffon     */
  27,  /* Orchid           */
   3,  /* Corn Silk        */
  23,  /* Dodger Blue      */
  28,  /* Pink         -30 */
  21,  /* Dark Blue        */
  18,  /* Sea Green        */
  10,  /* Dark Orange      */
  18,  /* Sea Green        */
   7   /* Dark Red     -35 */
};  



int OBJGetIGRIPColor (int Color)          /* From IGRIP-color */
{
  if (Color == -1)
    return -1;
  elsif (abs(Color) < 36)
    return IgripColors[abs(Color)-1];

  return 0;
}


int OBJSetIGRIPColor (int Color)          /* To   IGRIP-color */
{
  unsigned int count;

  Color = abs (Color);
  for (count = 0; count < (sizeof(IgripColors)/sizeof(int)); ++count)
    if (IgripColors[count] == Color)
      return -(count+1);

  return -1;
}
