#include "partGlobal.h"


#if 0
PART *PART_Load12 (FILE *fp, dual check)
{
  int     count;
  int     CurveNo, SurfNo;
  int     ObjectNo;
  char    letter;
  OBJECT *Obj = NULL;
  OBJECT *Last = NULL;
  PART   *Result = NULL;

  PRO_START ("\n")

  if (feof(fp))
    PRO_RETURN ("unexpected end-of-file", NULL)

  Result = PARTNewPart ();

  /* load coordinate systems */
  if (fscanf(fp, "%d\n", &Result->CSNo) < 1)
  {
    PARTFreePart (Result);
    PRO_RETURN ("missing coord-count", NULL)
  }
  PRO1 ("COORD-SYSTEMS: %d\n", Result->CSNo)
  if (Result->CSNo > 0)
  {
    Result->CS = (MATRIX *)malloc (sizeof(MATRIX) * Result->CSNo);
    for (count = 0; count < Result->CSNo; ++count)
      if (! PART_LoadMatrix(fp, &(Result->CS[count])))
      {
	PARTFreePart (Result);
	PRO_RETURN ("error while reading matrix", NULL)
      }
  }

  /* Curves */
  if (fscanf(fp, "%d\n", &CurveNo) < 1)
    CurveNo = -1;
  PRO1 ("CURVES:   %d\n", CurveNo)
  if (CurveNo < 0)
  {
    PARTFreePart (Result);
    PRO_RETURN ("Invalid Curve-amount", NULL)
  }
  elsif (CurveNo > 0)
    for (count = 0; count < CurveNo * 9; ++count)
      do
	letter = fgetc (fp);
      while (letter != '\n');

  /* Surfaces */
  if (fscanf(fp, "%d\n", &SurfNo) < 1)
    SurfNo = -1;
  PRO1 ("SURFACES: %d\n", SurfNo);
  if (SurfNo != 0)
  {
    PARTFreePart (Result); 
    PRO_RETURN ("Invalid surface amount", NULL)
  }

  /* now load all objects... */
  fscanf (fp, "%d\n", &ObjectNo);
  PRO1 ("OBJECTS: %d\n", ObjectNo)
  PolygonID = 0;
  for (count = 0; count < ObjectNo; ++count)
  {
    if ((Obj = PART_LoadObject12(fp, check)) == NULL)
    {
      PRO1 ("ERROR loading object %d\n", count+1)
      PARTFreePart (Result);
      PRO_RETURN ("error loading object", NULL)
    }

    if (Result->ObjectList == NULL)
      Result->ObjectList = Obj;
    else
      Last->Next = Obj;

    Last = Obj;
    (Result->ObjectNo)++;
  }

  PARTCalcPartInfo (Result);

  /* Calculate part-CS... */
  PART_CalcPartCoordSys (Result);

  PRO_END
  return Result;
}
#endif


dual PART_Write12 (FILE *fp, PART *Part)
{
  int     count;
  int     row;
  OBJECT *Obj;

  PRO_START (" ")

  if (fp == NULL || Part == NULL)
    return FALSE;

  fprintf (fp, "12\n");                           /* Version-No */ 

  fprintf (fp, "%d\n", Part->CSNo);
  if (Part->CSNo > 0)
  {
    for (count = 0; count < Part->CSNo; ++count)
      for (row = 0; row < 4; ++row)
	fprintf (fp, "%f %f %f\n", 
		     Part->CS[count].m[row][0],
		     Part->CS[count].m[row][1],
		     Part->CS[count].m[row][2]);
  }
  fprintf (fp, "0\n");                            /* amount of curves */
  fprintf (fp, "0\n");                            /* amount of surfaces */

  fprintf (fp, "%d\n", Part->ObjectNo);

  Obj = Part->ObjectList;
  while (Obj != NULL)
  {
    if (! OBJWriteV12 (fp, Obj))
      break;

    Obj = Obj->Next;
  }
  fclose (fp);

  PRO_END
  return TRUE;
}

