#include "libpart.h"


int main (int argc, char **argv)
{
  PART   *Part = NULL;
  PART   *Part1, *Part2;

  if (argc < 3)
  {
    printf ("Syntax: %s <PartFile1> <PartFile2>\n", argv[0]);
    return 1;
  }
  else
  {
    printf ("Loading...\n");
    if ((Part1 = PARTLoad(argv[1], "part1", TRUE)) == NULL)
    {
      printf ("Part1 failed\n");
      return -1;
    }

    if ((Part2 = PARTLoad(argv[2], "part2", TRUE)) == NULL)
    {
      printf ("Part2 failed\n");
      return -2;
    }

#if 0
    Part = PARTDifference ("difference", Matrix1, Part1, Matrix_1,
			   Part2, GEOMakeTrans(1.0, 1.0, 1.0), 10);
#else
    Part = PARTIntersection ("intersection", Matrix_1, 
			     Part1, Matrix_1, Part2, Matrix_1, 10);
#endif
    if (Part != NULL)
      PARTFreePart (Part);
  }

  /*
    cube02_0.part cube13.part      Ecken von Wrfeln schneiden sich
    cube04_x2.part cube13.part     Wrfel in grerer Wrfelseite
    cube04_x2.part quad137.part    Quader durchdringt Wrfel
  */

  return 0;
}
