#include "libsim3d.h"


DHP::DHP (double d /* = 0.0 */, double Theta /* = 0.0 */,
          double a /* = 0.0 */, double Alpha /* = 0.0 */, 
	  JOINT_TYPE Type /* = ROT */) :
  Type  (Type),
  d     (d),
  Theta (Theta),
  a     (a),
  Alpha (Alpha)
{
}


DHP::DHP (FRAME An)
{
  An.GetDHP (&Theta, &d, &a, &Alpha);
  printf ("DHP: THETA=%7.2f D=%6.2f A=%6.2f ALPHA=%7.2f\n", 
	  Theta, d, a, Alpha);  
}


DHP::JOINT_TYPE DHP::GetType () const
{
  return Type;
}


double DHP::GetD () const
{ 
  return d;
} 


double DHP::GetTheta () const
{ 
  return Theta;
}


double DHP::GetA () const
{ 
  return a;
}


double DHP::GetAlpha () const
{ 
  return Alpha;
}


FRAME DHP::GetAMatrix () const
{
  FRAME Result;

  return Result;
}
