#include "libsim3d.h"


KINEMATIC::KINEMATIC () :
  EpsilonJoint (3.0, 3.0, 3.0, 2.5, 2.5, 2.5),
  JointMin     (-160.0, -217.5, -39.5, -270.0, -109.5, -270.0),
  JointMax     ( 160.0,   37.5, 224.5,  270.0,  120.5,  270.0),
  Base         (),
  Offset       ()
{
}


KINEMATIC::~KINEMATIC ()
{
}


void KINEMATIC::SetJointRange (const JOINTS &Min, const JOINTS &Max)
{
  JointMin = Min;
  JointMax = Max;
}


void KINEMATIC::SetEpsilonJoint (double Epsilon)
{
  EpsilonJoint = Epsilon;  
}


void KINEMATIC::SetBase (const FRAME &BaseFrame) 
{
  Base = BaseFrame;
}


void KINEMATIC::SetOffset (const FRAME &TCPOffs)
{
  Offset = TCPOffs;
}


JOINTS KINEMATIC::GetEpsilonJoint ()
{
  return EpsilonJoint;
}


double KINEMATIC::GetEpsilonJoint (int JointNo)
{
  return EpsilonJoint[JointNo];
}


FRAME KINEMATIC::GetBase ()
{ 
  return Base;
}


FRAME KINEMATIC::GetOffset ()
{
  return Offset;
}


JOINTS KINEMATIC::GetHome ()
{
  return Home;
}
