#include "libsim3d.h"


// Constructor / Destructor:
ROBOT::ROBOT (INTERFACE *Interf /* = NULL */) :
  TRAJECTORY (NULL, Interf),
  Interface (Interf),
  Speed     (1.0) /* [m/sec] */
{
  //           SetKinematic (this);
};


ROBOT::~ROBOT () 
{
  if (Interface != NULL)
    delete Interface;
};


// virtual functions:
// TODO: Als Namespace ?
bool ROBOT::SetSpeed (double Speed) 
{ 
  if (Speed <= 0.0)
    return FALSE;

  this->Speed = Speed;
  SetInterpPerMeter (int((1000 / GetClock()) / Speed));

  return (Interface != NULL)? Interface->SetSpeed(Speed):FALSE;
}


double ROBOT::GetSpeed ()
{
  return (Interface != NULL)? Interface->GetSpeed():(-1);
}


bool ROBOT::OpenHand ()
{
  return (Interface != NULL)? Interface->OpenHand():FALSE;
}


bool ROBOT::CloseHand ()
{
  return (Interface != NULL)? Interface->CloseHand():FALSE;
}


int ROBOT::GetHand ()
{
  return (Interface != NULL)? Interface->GetHand():FALSE;
}


bool ROBOT::Place (const JOINTS &Joint)
{
  return (Interface != NULL)? Interface->Place(Joint):FALSE;
}


bool ROBOT::Break ()
{
  return (Interface != NULL)? Interface->Break():FALSE;
}


JOINTS ROBOT::GetRobotPos ()
{
  return (Interface != NULL)? Interface->GetRobotPos():JOINTS();
}


FRAME ROBOT::GetPos ()
{
  return (Interface != NULL)? Interface->GetPos():FRAME();
}


FRAME ROBOT::Teach (char *Msg /* = NULL */, ...)
{
  return (Interface != NULL)? Interface->Teach(Msg):FRAME();
}
