#include <assert.h>

#include "tuxCAD.h"

/* Realisation of a transfer-buffer for copy and paste actions */


BUFFER Buffer;


BUFFER::BUFFER () :
  DevList ()
{
}


BUFFER::~BUFFER ()
{
  Clear ();
}


void BUFFER::Add (PART3D *Part)
{
  DEVICE3D *Dev;

  if (Part != NULL)
  {
    Dev = new DEVICE3D ("buffer", Part);
    DevList.Add (Dev);
  }
}


void BUFFER::Add (DEVICE3D *Dev)
{
  if (Dev != NULL)
    DevList.Add (Dev);
}


void BUFFER::Clear ()
{
  DEVICE3D *Dev;

  while (DevList.Size() > 0)
  {
    Dev = DevList.Get (0);
    DevList.Delete (Dev);
    delete Dev;
  }
}


int BUFFER::Size () const
{
  return DevList.Size ();
}


LIST<DEVICE3D *> *BUFFER::GetBuffer ()
{
  return &DevList;
}

