#include "tuxCAD.h"


CAD_DIALOG::CAD_DIALOG (int SizeX /* = -1 */, int SizeY /* = -1 */) :
  Dlg    (NULL),
  PosX   (-1),
  PosY   (-1),
  SizeX  (SizeX),
  SizeY  (SizeY),
  Handle (NULL)
{
  PRO_METHOD ("CAD_DIALOG", "")

  PRO_END
}


CAD_DIALOG::~CAD_DIALOG ()
{
  PRO_METHOD ("~CAD_DIALOG", "")

  if (Dlg != NULL)
  {
    DLGCloseDialog (Dlg);
    DLGFreeDialog  (Dlg);  
  }

  PRO_END
}


bool CAD_DIALOG::Open ()
{
  PRO_METHOD ("CAD_DIALOG", "")

  if (Dlg != NULL)
  {
    PRGPrintf (MSG_DIALOG_OPEN);
    PRO_RETURN ("Dialog is already open", FALSE)
  }

  Dlg = DLGNewDialog (0);

  PRO_END
  return (Dlg != NULL);
}


bool CAD_DIALOG::Close ()
{
  PRO_METHOD ("CAD_DIALOG", "")

  if (Dlg == NULL)
    PRO_RETURN ("Dialog not open", FALSE)

  // Save dialog size and position
#if 0
  DLGGetPos  (Dlg, &PosX,  &PosY);
  DLGGetSize (Dlg, &SizeX, &SizeY);
#endif

  DLGCloseDialog (Dlg);

  DLGFreeDialog (Dlg);
  Dlg = NULL;  

  PRO_END
  return TRUE;
}


void CAD_DIALOG::ChangeCB (int BoxID)
{
  if (Handle != NULL)
    Handle (Dlg, BoxID);
}


void CAD_DIALOG::HelpCB (int ID)
{
  Manual ();
}


void CAD_DIALOG::OnChange (CHANGE_HANDLE Handle)
{
  this->Handle = Handle;
}


void HelpDlgCB (DIALOG *Dlg, int ID)
{
  CAD_DIALOG *Dialog = (CAD_DIALOG *)DLGGetUserData (Dlg, 0);

  if (Dialog != NULL)
    Dialog->HelpCB (ID);
}
