#ifndef _LIBFILTER_H_
#define _LIBFILTER_H_

#include <libcad3d.h>


typedef char *(*NAME_FUNC)();
typedef WORLD *(*LOAD_FUNC)(const char *FileSpec, const char *DataPath);
typedef PART3D *(*IMP_PART_FUNC)(WORLD *World,
				 const char *FileSpec, const char *DataPath);
typedef DEVICE3D *(*IMP_DEV_FUNC)(WORLD *World, 
				  const char *FileSpec, const char *DataPath);
typedef WORLD *(*IMP_WORLD_FUNC)(WORLD *World,
				 const char *FileSpec, const char *DataPath);


char      *GetName       ();

bool       Check         (const char *FileSpec);

WORLD     *Load          (const char *FileSpec, const char *DataPath);
bool       Save          (WORLD *World,         const char *FileSpec);

PART3D    *ImportPart    (WORLD *World,         const char *FileSpec);
DEVICE3D  *ImportDevice  (WORLD *World, 
			  const char *FileSpec, const char *DataPath);
WORLD     *ImportWorld   (WORLD *World, 
			  const char *FileSpec, const char *DataPath);

bool       ExportPart    (PART3D   *Part, const char *FileSpec);
bool       ExportDevice  (DEVICE3D *Dev,  const char *FileSpec);

bool       WritePart     (FILE *fp, PART3D   *Part);
bool       WriteDevice   (FILE *fp, DEVICE3D *Dev);
bool       WriteWorld    (FILE *fp, WORLD    *World);

PART3D    *ReadPart      (FILE *fp, double Version);
DEVICE3D  *ReadDevice    (FILE *fp, double Version, const char *DataPath);
WORLD     *ReadWorld     (FILE *fp, double Version, const char *DataPath);


#endif
