#include "tuxCAD.h"


static FOG::MODE FogModes[] = 
{
  FOG::OFF, 
  FOG::OFF,                             // separator line
  FOG::LINEAR, 
  FOG::EXP,
  FOG::EXP2
};

static FOG::HINT FogHints[] =
{
  FOG::DONT_CARE,
  FOG::DONT_CARE,                       // separator line
  FOG::FASTEST, 
  FOG::NICEST
};



FOG *FogCB (DIALOG *Dlg, int BaseID, FOG *Fog, int BoxID)
{
  int Selection;

  switch (BoxID-BaseID)
  {
    case 11 :
      Selection = DLGGetOMenu (Dlg, BoxID);
      Fog->SetMode (FogModes[Selection]);
      DLGSetBoxActive (Dlg, BaseID+15, (Selection > 2));
      DLGSetBoxActive (Dlg, BaseID+16, (Selection == 2));
      DLGSetBoxActive (Dlg, BaseID+17, (Selection == 2));
      break;

    case 12 :
      Selection = DLGGetOMenu (Dlg, BoxID);
      Fog->SetHint (FogHints[Selection]);
      break;

    case 15 :
      Fog->SetDensity (DLGGetScale(Dlg, BoxID));
      break;

    case 16 :
    case 17 :
      Fog->SetRange (DLGGetScale(Dlg, BaseID+16), DLGGetScale(Dlg, BaseID+17));
      break;

    default :
      Fog->SetColor (ColorCB(Dlg, BaseID+20, Fog->GetColor(), 
                             BoxID, ALPHA_MASK));
  }

  return Fog;
}


void FogDialog (DIALOG *Dlg, int BaseID, FOG *Fog)
{
  int FogMode = Fog->GetMode ();
  int FogHint = Fog->GetHint ();

  PRO_START ("")

  DLGMakeCols (Dlg, BaseID,    2, DlgETCHED_IN, BaseID+10, BaseID+20);
  DLGMakeRows (Dlg, BaseID+10, 5, DlgNO_LINE 
	                          DlgETCHED_IN DlgETCHED_IN DlgNO_LINE,
                                  BaseID+11, BaseID+12, 
		                  BaseID+15, BaseID+16, BaseID+17);

  if (FogMode != FOG::OFF)
    FogMode++;
  if (FogHint != FOG::DONT_CARE)
    FogHint++;

  DLGInsertOMenu  (Dlg, BaseID+11, "fogMode", 5, 
		                   "off", NULL, "linear", "exp", "exp2", 
		                   FogMode);
  DLGInsertOMenu  (Dlg, BaseID+12, "hint", 4,
		                   "dontCare", NULL, "fastest", "nicest", 
		                   FogHint);
  DLGInsertScale  (Dlg, BaseID+15, "density", 0.0, 1.0, Fog->GetDensity(), 
		                              2, DlgHORIZONTAL);
  DLGInsertScale  (Dlg, BaseID+16, "start",   0.0, 10000.0, Fog->GetStart(), 
                                              1, DlgHORIZONTAL);
  DLGInsertScale  (Dlg, BaseID+17, "end",     0.0, 10000.0, Fog->GetEnd(), 
		                              1, DlgHORIZONTAL);

  DLGSetBoxActive (Dlg, BaseID+15, (FogMode > 2));
  DLGSetBoxActive (Dlg, BaseID+16, (FogMode == 2));
  DLGSetBoxActive (Dlg, BaseID+17, (FogMode == 2));

  ColorDialog     (Dlg, BaseID+20, Fog->GetColor(), ALPHA_MASK);

  PRO_END
}




