#include "tuxCAD.h"


static char *Names[] = 
{
  "translateX", "translateY", "translateZ",
  "rotateX",    "rotateY",    "rotateZ"
};


JOINT *JointCB (DIALOG *Dlg, int BaseID, PART3D *Part, int BoxID)
{
  int count;

  if (((BoxID-BaseID) % 10) == 1)
    for (count = 1; count <= 3; count++)
      DLGSetBoxActive (Dlg, BoxID+count, DLGGetBool(Dlg, BoxID));

  // TODO Werte eintragen

  return &Part->GetJoint ();
}


void MakeDirection (DIALOG *Dlg, int BaseID, PART3D *Part, int Axis)
{
  int count;

  DLGMakeRows (Dlg, BaseID, 4, DlgNO_LINE,
 	                       BaseID+1, BaseID+2, BaseID+3, BaseID+4);
  DLGInsertBool   (Dlg, BaseID+1, "free", Part->GetJoint().IsFree(Axis));
  DLGInsertDouble (Dlg, BaseID+2, "min", 
		                  Part->GetJoint().GetMin(Axis), 9, 3);
  DLGInsertDouble (Dlg, BaseID+3, "max",
		                  Part->GetJoint().GetMax(Axis), 9, 3);
  DLGInsertDouble (Dlg, BaseID+4, "value", Part->GetVal(Axis), 9, 3);
  DLGSetBorder    (Dlg, BaseID, DlgETCHED_IN);
  DLGSetTitle     (Dlg, BaseID, Names[Axis], DlgLEFT);

  for (count = 2; count < 5; ++count)
    DLGSetBoxActive (Dlg, BaseID+count, Part->GetJoint().IsFree(Axis));
}


void JointDialog (DIALOG *Dlg, int BaseID, PART3D *Part)
{
  int count;

  DLGMakeRows (Dlg, BaseID,   2, DlgNO_LINE, BaseID+1, BaseID+5);
  DLGMakeCols (Dlg, BaseID+1, 3, DlgNO_LINE, BaseID+10, BaseID+20, BaseID+30);
  DLGMakeCols (Dlg, BaseID+5, 3, DlgNO_LINE, BaseID+50, BaseID+60, BaseID+70);
  for (count = POS_X; count <= POS_Z; ++count)
    MakeDirection (Dlg, BaseID+10+count*10, Part, count);
  for (count = ROT_X; count <= ROT_Z; ++count)
    MakeDirection (Dlg, BaseID+20+count*10, Part, count);
}


