#include <math.h>

#include "tuxCAD.h"


static void PlotSelectHandle (PLOT3D *Plot, 
			      int Button, int MouseX, int MouseY)
{
  //  SetCurrentWorld (Plot);
  
  switch (Button)
  {
    case 3 :
      PRGPrintf ("Selected World: %s", Plot->GetName());
 
      PRGCreateMenu (Plot->GetWin()->GetShell(), "worldMenu", MouseX, MouseY, 
		     WorldMenu, WorldMenuEntries);
      if (Plot != NULL)
	Plot->Redraw ();
      break;

    default :
      break;
  }
}


#define SIZE_X  40
#define SIZE_Y  40
#define RANGE_MINX  -10.0
#define RANGE_MAXX   10.0
#define RANGE_MINY  -10.0
#define RANGE_MAXY   10.0

void Plot3D ()
{
  int       countX, countY;
  double    OffsX, OffsY;
  double    StepX, StepY;
  double    Dist;
  PLOT3D   *Plot;
  POINT3D **Points;

  Plot = new PLOT3D ("3dPlot");
  InsWorld (Plot);

  // Create Data
  Points = new POINT3D *[SIZE_X];
  for (countX = 0; countX < SIZE_X; ++countX)
    Points[countX] = new POINT3D [SIZE_Y];

  OffsX = - 0.5 * (RANGE_MINX + RANGE_MAXX);
  OffsY = - 0.5 * (RANGE_MINY + RANGE_MAXY);
  StepX = (RANGE_MAXX - RANGE_MINX) / double(SIZE_X-1);
  StepY = (RANGE_MAXY - RANGE_MINY) / double(SIZE_Y-1);

  for (countY = 0; countY < SIZE_Y; ++countY)
    for (countX = 0; countX < SIZE_X; ++countX)
    {
      Points[countX][countY].x = RANGE_MINX + countX * StepX;
      Points[countX][countY].y = RANGE_MINY + countY * StepY;
      Dist = sqrt (Points[countX][countY].x*Points[countX][countY].x + 
		   Points[countX][countY].y*Points[countX][countY].y);
      Points[countX][countY].z = 5.0 * (exp (-Dist / 3.0) * cos (Dist*2.0));
    }
 
  Plot->SetValues (SIZE_Y, SIZE_X, Points);

  for (countX = 0; countX < SIZE_X; ++countX)
    delete Points[countX];
  delete Points;

  Plot->SetUserMouseHandle  ((MOUSE_HANDLE) WorldMouseHandle);
  Plot->SetUserSelectHandle ((SELECT_HANDLE)PlotSelectHandle);
  Plot->SetUserButtonHandle ((BUTTON_HANDLE)ButtonHandle);
  Plot->SetUserKeyHandle    ((KEY_HANDLE)   KeyHandle);
}
