#include "tuxCAD.h"


SHADOW *ShadowCB (DIALOG *Dlg, int BaseID, SHADOW *Shadow, int BoxID)
{
  if (Shadow == NULL)
    return NULL;

  switch (BoxID-BaseID)
  {
    case 1 :
      {
	bool Mode = (bool)DLGGetOMenu (Dlg, BoxID);

	Shadow->SetMode ((SHADOW::MODE)Mode);
	DLGSetBoxActive (Dlg, BaseID+2, Mode);
      }
      break;

    default :
      Shadow->SetColor (ColorCB(Dlg, BaseID+2, Shadow->GetColor(), BoxID, 
				ALPHA_MASK));
      break;
  }

  return Shadow;
}


void SetShadow (DIALOG *Dlg, int BaseID, SHADOW *Shadow)
{
  bool Mode;

  if (Shadow == NULL)
    return;

  Mode = (Shadow->GetMode() == SHADOW::ON);
  DLGSetOMenu (Dlg, BaseID+1, Mode);
  SetColor    (Dlg, BaseID+2, Shadow->GetColor(), ALPHA_MASK);

  DLGSetBoxActive (Dlg, BaseID+2, Mode);
}


void ShadowDialog (DIALOG *Dlg, int BaseID, SHADOW *Shadow)
{
  bool Mode;

  PRO_START ("")

  if (Shadow == NULL)
    return;

  Mode = (Shadow->GetMode() == SHADOW::ON);

  DLGMakeRows (Dlg, BaseID, 2, DlgNO_LINE, BaseID+1, BaseID+2);
  DLGInsertOMenu (Dlg, BaseID+1, "shadowMode", 2, "off", "on", Mode);
  ColorDialog    (Dlg, BaseID+2, Shadow->GetColor(), ALPHA_MASK);

  DLGSetBoxActive (Dlg, BaseID+2, Mode);

  /*
    TODO:
    Schalter: Farbe fr alle Lichtquellen ndern
    Definition der Projektions-Ebene
    Schattenart: harter/weicher Schatten ?
  */

  PRO_END
}
