#include <Xm/Form.h>

#include "tuxCAD.h"


static bool ToolBarVisible = TRUE;


void SwapToolbar ()
{
  ToolBarVisible = ! ToolBarVisible;

  PRGShowToolBar (ToolBarVisible);
}


void ReadDataFile ()
{
  FILE *fp = NULL;

  // ========== Test file ops for materials (include colors) ==========
  MATERIAL  Material1 (COLOR::MEDRED);
  MATERIAL  Material2;
  if ((fp = fopen("/tmp/material1.dat", "w+")) != NULL)
  {
    printf ("Writing Material...%d\n", Material1.Write(fp));
    fclose (fp);

    DATAFILE File ("/tmp/material1.dat");
    printf ("Reading Material...%d\n", Material2.Read(File, 1.0));
    if ((fp = fopen("/tmp/material2.dat", "w+")) != NULL)
    {
      Material2.Write (fp);
      fclose (fp);
    }
  }

  // ========== Test file ops for joints ==========
  JOINT  Joint1 ((1<<POS_Y)|(1<<ROT_X)|(1<<ROT_Z));
  JOINT  Joint2 (0);
  if ((fp = fopen("/tmp/joint1.dat", "w+")) != NULL)
  {
    printf ("Writing Joint...%d\n", Joint1.Write(fp));
    fclose (fp);

    DATAFILE File ("/tmp/joint1.dat");
    printf ("Reading Joint...%d\n", Joint2.Read(File, 1.0));
    if ((fp = fopen("/tmp/joint2.dat", "w+")) != NULL)
    {
      Joint2.Write (fp);
      fclose (fp);
    }
  }

  // ========== Test file ops for lines ==========
  LINE_STYLE Line1 (COLOR::MEDRED, 2, 0x55aa);
  LINE_STYLE Line2;
  if ((fp = fopen("/tmp/line1.dat", "w+")) != NULL)
  {
    printf ("Writing Line...%d\n", Line1.Write(fp));
    fclose (fp);

    DATAFILE File ("/tmp/line1.dat");
    printf ("Reading Line...%d\n", Line2.Read(File, 1.0));
    if ((fp = fopen("/tmp/line2.dat", "w+")) != NULL)
    {
      Line2.Write (fp);
      fclose (fp);
    }
  }

  // ========== Test file ops for textures ==========
  TEXTURE Texture1 ("/users/stefan/tuxcad/data/TEXTURES/wood.xpm");
  TEXTURE Texture2 (NO_TEXTURE);
  if ((fp = fopen("/tmp/texture1.dat", "w+")) != NULL)
  {
    printf ("Writing Texture...%d\n", Texture1.Write(fp));
    fclose (fp);

    DATAFILE File ("/tmp/texture1.dat");
    printf ("Reading Texture...%d\n", Texture2.Read(File, 1.0));
    if ((fp = fopen("/tmp/texture2.dat", "w+")) != NULL)
    {
      Texture2.Write (fp);
      fclose (fp);
    }
  }

  // ========== Test file ops for lights ==========
  LIGHT Light1 (LIGHT::LIGHT6);
  LIGHT Light2 (LIGHT::LIGHT1);
  if ((fp = fopen("/tmp/light1.dat", "w+")) != NULL)
  {
    printf ("Writing Light...%d\n", Light1.Write(fp));
    fclose (fp);

    DATAFILE File ("/tmp/light1.dat");
    printf ("Reading Light...%d\n", Light2.Read(File, 1.0));
    if ((fp = fopen("/tmp/light2.dat", "w+")) != NULL)
    {
      Light2.Write (fp);
      fclose (fp);
    }
  }

  // ========== Test file ops for shadows ==========
  SHADOW Shadow1 (new LIGHT(LIGHT::LIGHT6));
  SHADOW Shadow2 (new LIGHT(LIGHT::LIGHT1));
  if ((fp = fopen("/tmp/shadow1.dat", "w+")) != NULL)
  {
    printf ("Writing Shadow...%d\n", Shadow1.Write(fp));
    fclose (fp);

    DATAFILE File ("/tmp/shadow1.dat");
    printf ("Reading Shadow...%d\n", Shadow2.Read(File, 1.0));
    if ((fp = fopen("/tmp/shadow2.dat", "w+")) != NULL)
    {
      Shadow2.Write (fp);
      fclose (fp);
    }
  }

  // ========== Test file ops for fog ==========
  FOG Fog1;
  FOG Fog2;
  if ((fp = fopen("/tmp/fog1.dat", "w+")) != NULL)
  {
    printf ("Writing Fog...%d\n", Fog1.Write(fp));
    fclose (fp);

    DATAFILE File ("/tmp/fog1.dat");
    printf ("Reading Fog...%d\n", Fog2.Read(File, 1.0));
    if ((fp = fopen("/tmp/fog2.dat", "w+")) != NULL)
    {
      Fog2.Write (fp);
      fclose (fp);
    }
  }

  // ========== Test file ops for projections ==========
  PROJECTION Prj1;
  PROJECTION Prj2;
  if ((fp = fopen("/tmp/prj1.dat", "w+")) != NULL)
  {
    printf ("Writing Prj...%d\n", Prj1.Write(fp));
    fclose (fp);

    DATAFILE File ("/tmp/prj1.dat");
    printf ("Reading Prj...%d\n", Prj2.Read(File, 1.0));
    if ((fp = fopen("/tmp/prj2.dat", "w+")) != NULL)
    {
      Prj2.Write (fp);
      fclose (fp);
    }
  }

  // ========== Test file ops for cameras ==========
  CAMERA Camera1;
  CAMERA Camera2;
  if ((fp = fopen("/tmp/camera1.dat", "w+")) != NULL)
  {
    printf ("Writing Camera...%d\n", Camera1.Write(fp));
    fclose (fp);

    DATAFILE File ("/tmp/camera1.dat");
    printf ("Reading Camera...%d\n", Camera2.Read(File, 1.0));
    if ((fp = fopen("/tmp/camera2.dat", "w+")) != NULL)
    {
      Camera2.Write (fp);
      fclose (fp);
    }
  }

  // ========== Test file ops for views ==========
  VIEW View1 (10, 10);
  VIEW View2 (0, 0);
  if ((fp = fopen("/tmp/view1.dat", "w+")) != NULL)
  {
    printf ("Writing View...%d\n", View1.Write(fp));
    fclose (fp);

    DATAFILE File ("/tmp/view1.dat");
    printf ("Reading View...%d\n", View2.Read(File, 1.0));
    if ((fp = fopen("/tmp/view2.dat", "w+")) != NULL)
    {
      View2.Write (fp);
      fclose (fp);
    }
  }

  // ========== Test file ops for floors ==========
  FLOOR Floor1;
  FLOOR Floor2;
  if ((fp = fopen("/tmp/floor1.dat", "w+")) != NULL)
  {
    printf ("Writing Floor...%d\n", Floor1.Write(fp));
    fclose (fp);

    DATAFILE File ("/tmp/floor1.dat");
    printf ("Reading Floor...%d\n", Floor2.Read(File, 1.0));
    if ((fp = fopen("/tmp/floor2.dat", "w+")) != NULL)
    {
      Floor2.Write (fp);
      fclose (fp);
    }
  }

  // ========== Test file ops for boxes ==========
  BOX Box1 (10, 10, 10);
  BOX Box2 ( 0,  0,  0);
  if ((fp = fopen("/tmp/box1.dat", "w+")) != NULL)
  {
    printf ("Writing Box...%d\n", Box1.Write(fp));
    fclose (fp);

    DATAFILE File ("/tmp/box1.dat");
    printf ("Reading Box...%d\n", Box2.Read(File, 1.0));
    if ((fp = fopen("/tmp/box2.dat", "w+")) != NULL)
    {
      Box2.Write (fp);
      fclose (fp);
    }
  }

  // ========== Test file ops for parts ==========
  PART3D Part1 (PARTLoad("/users/stefan/tuxcad/data/PARTS/v11/block_2.part",
			 "BLOCK", TRUE), NULL, MATERIAL(COLOR::MEDRED));
  PART3D Part2;
  if ((fp = fopen("/tmp/part1.dat", "w+")) != NULL)
  {
    printf ("Writing Part...%d\n", Part1.Write(fp));
    fclose (fp);

    DATAFILE File ("/tmp/part1.dat");
    printf ("Reading Part...%d\n", Part2.Read(File, 1.0));
    if ((fp = fopen("/tmp/part2.dat", "w+")) != NULL)
    {
      Part2.Write (fp);
      fclose (fp);
    }
  }


}


static WORKCELL *Prev = NULL;
static SPHERE   *Demo;

static void PreviewHandle (Widget widget, CREATE_DIALOG *Dlg, XEvent *Event)
{
printf ("EventType: %d\n", Event->type);

  if (Event->type == MapNotify)
  {
    Prev = new WORKCELL (widget, "preview");
    SetCurrent (Prev);
    Demo = new SPHERE (Prev, "sphere", GEOMakeRot(Vector_Y, -90.0), 
		       10.0, 180.0, 180.0, 32, MATERIAL(COLOR::MEDRED));
    Prev->AddDevice (new DEVICE3D("preview", Demo));
    Prev->Fill      ();
    Prev->SetScale  (0.5);
  }
}

static Widget MakePreview (DIALOG *Dlg, Widget Parent, void *Param)
{
  Widget Form = XtVaCreateManagedWidget ("preview", xmFormWidgetClass, Parent, 
					            XmNwidth,  150,
					            XmNheight, 150, 
				                    NULL);
  XtAddEventHandler (Form, StructureNotifyMask, FALSE, 
		           (XtEventHandler)PreviewHandle, Param);
  return Form;
}

int Refresh (DIALOG *Dlg, int BoxID)
{
  if (Prev != NULL)
    Prev->Redraw ();

  return DlgACCEPT;
}

void Preview ()
{
  DIALOG *Dlg;

  Dlg = DLGNewDialog (0);
  DLGInsertNote (Dlg, 0, "preview", DlgNOBINDING);
  DLGAddPage (Dlg, 0, DlgMAJOR, "test", 100);

    DLGMakeRows (Dlg, 100, 2, DlgNO_LINE, 110, 120);
    DLGInsertProc   (Dlg, 110, "refresh", Refresh);
    DLGInsertWidget (Dlg, 120, MakePreview, (void *)Dlg);

  DLGOpenDialog (Dlg, "previewPart", DlgNORMAL, NULL);
}








