#include <X11/keysym.h>

#include "tuxCAD.h"


void ChangeParam (DIALOG *Dlg, int BoxID)
{
  PrgConfig ();
}


WORLD *NewWorld (char *Name)
{
  int     count = 0;
  char    WorldName[256];
  WORLD  *World;
  DIALOG *Dlg = NULL;

  if (Name == NULL)
  {
    Dlg = DLGNewDialog (0);
    sprintf (WorldName, "WorkCell%d", count+1);
    DLGInsertText (Dlg, 0, "name", 255, WorldName, 30, 1);

    DLGMakeButton (Dlg, CANCEL_BUTTON);
    DLGMakeButton (Dlg, USER_BUTTON, "param", DlgBUTTON_RIGHT, 
		                     ChangeParam, -5);
    DLGMakeButton (Dlg, OK_BUTTON);
    DLGOpenDialog (Dlg, "worldName", DlgNORMAL, NULL);
    if (DLGGetExitButton(Dlg) == DlgOK)
    {
      strncpy (WorldName, DLGGetText(Dlg, 0), 256);
      WorldName[255] = '\0';
      Name = WorldName;
    }
    DLGFreeDialog (Dlg);
  }

  if (Name != NULL)
  {
    World = new WORKCELL (Name);
    InsWorld (World);
    World->GetFloor()->SetMode (TOOLGetConfigBool(CFG_CREATE_FLOOR)? 
				  FLOOR::ON : FLOOR::OFF);
    SetWorldHandles (UPDATE(World));
  }

  return GetCurrent ();
}


// TODO: durch DelWorld ersetzen
bool DeleteWorld (WORLD *World)
{
  if (World == NULL)
    return TRUE;

  DelWorld (World);

  return TRUE;
}


void WorldMouseCursor (WORLD *World, int Cursor /* = -1 */)
{
  int    count;
  WORLD *TmpWorld;

  for (count = 0; count < GetWorldNo(); ++count)
  {
    TmpWorld = GetWorld (count);
    if (TmpWorld != NULL && (TmpWorld == World || World == NULL))
    {
      if (Cursor < 0)
	switch (GetAction(TmpWorld))
	{
          case DATA::TRANS_ABSOLUTE :
          case DATA::TRANS_RELATIVE :
          case DATA::MOVE_TRANSLATE :
          case DATA::PAN_MODE :
          case DATA::TCP_TRANS_REL :
          case DATA::TCP_TRANS_ABS :
	    TmpWorld->SetMouseCursor (XC_fleur);
	    break;

          case DATA::ROT_ABSOLUTE :
          case DATA::ROT_RELATIVE :
          case DATA::MOVE_ROTATE :
          case DATA::TCP_ROT_REL :
          case DATA::TCP_ROT_ABS :
	    TmpWorld->SetMouseCursor (XC_exchange);
	    break;

          case DATA::ZOOM_INTERACTIVE :
          case DATA::ZOOM_DISCRETE :
            TmpWorld->SetMouseCursor (ToolMAGNIFIER);
	    break;

          default : 
	    TmpWorld->SetMouseCursor (ToolNORMAL);
	}
      else
	TmpWorld->SetMouseCursor (Cursor);

      if (World != NULL)
	return;
    }
  }
}


WORLD *SelectWorld (bool Create, int Cursor /* = ToolNORMAL */,
		    int *x /* = NULL */, int *y /* = NULL */, 
		    int *Button /* = NULL */)
{
  XEvent  Event;
  int     count;
  KeySym  keySym;
  char    buffer[10];
  WORLD  *World = NULL;

  if (GetWorldNo() <= 0)
  {
    if (Create)
      World = NewWorld (NULL);
    return World;
  }

  WorldMouseCursor (NULL, Cursor);

  for (;;) 
  {
    if (XtAppPeekEvent(AppCon, &Event))
    {
      XtAppNextEvent (AppCon, &Event);
      if (Event.type == KeyPress) 
      {
        XLookupString (&Event.xkey, buffer, sizeof(buffer)-1, &keySym, NULL);
        
        if (keySym == XK_Escape) 
	  break;

	XtDispatchEvent (&Event);
      } 
      elsif ((Event.type == ButtonPress) &&
	     ((Event.xbutton.button == Button1) ||
	      (Create && (Event.xbutton.button == Button3))))
      {
	if (Event.xbutton.button == Button3)
	{
	  World = NewWorld (NULL);
	  break;
	}

	count = 0;
	while (count < GetWorldNo() && 
	       GetWorld(count)->GetWin()->GetWindow() != Event.xbutton.window)
	  count++;

	if (count < GetWorldNo())
        {
          if (x != NULL)
	    *x = Event.xbutton.x;
	  if (y != NULL)
	    *y = Event.xbutton.y;
	  World = GetWorld (count);
	  break;
        }
	else
	  PRGPrintf (MSG_SELECT_WINDOW);

        XtDispatchEvent (&Event);
      }
    }
    else
      XtAppProcessEvent (AppCon, XtIMAll);
  }

  if (Button != NULL)
    *Button = (int)Event.xbutton.button;

  SetCurrent (World);
  WorldMouseCursor (NULL);

  if (World == NULL)
    PRGPrintf (MSG_ABORT);

  return World;
}


bool CheckWorld (bool create /* = FALSE */)
{
  bool Result = FALSE;
  WORLD *World = GetCurrent();

  if (World != NULL)
    return TRUE;

  if ((World = SelectWorld(create)) == NULL)
  {
    NewWorld ();
    Result = TRUE;
  }

  return Result;
}
